## yass-1.20.4.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)

if (CMAKE_CURRENT_BINARY_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
  message(FATAL_ERROR "In source-tree build not support")
endif()

# Compiler id for Apple Clang is now AppleClang.
# https://cmake.org/cmake/help/latest/policy/CMP0025.html
if (POLICY CMP0025)
  cmake_policy(SET CMP0025 NEW)
endif (POLICY CMP0025)

# Project version variables are the empty string if version is unspecified
if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif (POLICY CMP0048)

# Honor link flags in try_compile() source-file signature.
if (POLICY CMP0056)
  cmake_policy(SET CMP0056 NEW)
endif (POLICY CMP0056)

# Include file check macros honor CMAKE_REQUIRED_LIBRARIES.
set(CMAKE_POLICY_DEFAULT_CMP0075 NEW)
if (POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif (POLICY CMP0075)

# Select the MSVC runtime library for use by compilers targeting the MSVC ABI.
# Use MSVC_CRT_LINKAGE variable internally, option: dynamic and static
#
# Introduced by cmake 3.15
# https://cmake.org/cmake/help/latest/variable/CMAKE_MSVC_RUNTIME_LIBRARY.html#variable:CMAKE_MSVC_RUNTIME_LIBRARY
# and https://cmake.org/cmake/help/latest/policy/CMP0091.html
if(POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif()

# The OLD behavior of this policy is to only allow GENERATED to be
# visible from the directory scope for which it was set.  The NEW
# behavior on the other hand allows it to be visible from any scope.
#
# Turn on Fix on https://gitlab.kitware.com/cmake/cmake/-/issues/18399
# Introduced by cmake 3.20
if(POLICY CMP0118)
  cmake_policy(SET CMP0118 NEW)
endif()

# https://docs.microsoft.com/en-us/cpp/c-runtime-library/crt-library-features?redirectedfrom=MSDN&view=msvc-170
set(MSVC_CRT_LINKAGE "dynamic" CACHE STRING "")
if (NOT MSVC_CRT_LINKAGE STREQUAL "static" AND NOT MSVC_CRT_LINKAGE STREQUAL "dynamic")
  message(FATAL_ERROR "MSVC_CRT_LINKAGE only accepts: dynamic or static")
endif()
set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>$<$<STREQUAL:${MSVC_CRT_LINKAGE},dynamic>:DLL>")

# Use relative paths (May not work!).
set(CMAKE_USE_RELATIVE_PATHS TRUE)

# update LAST_CHANGE file
# format d740da257583289dbebd2eb37e8668928fac5ead-refs/branch-heads/4692{32}
find_program(GIT_EXECUTABLE NAMES git git.exe git.cmd)
if(NOT GIT_EXECUTABLE STREQUAL "GIT_EXECUTABLE-NOTFOUND" AND EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git)
  execute_process(COMMAND
    ${GIT_EXECUTABLE} rev-parse HEAD
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE _LAST_CHANGE_REF
    OUTPUT_STRIP_TRAILING_WHITESPACE)

  execute_process(COMMAND
    ${GIT_EXECUTABLE} describe --abbrev=0 --tags HEAD
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE YASS_APP_TAG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    ERROR_QUIET)

  execute_process(COMMAND
    ${GIT_EXECUTABLE} rev-list ${YASS_APP_TAG}..HEAD --count
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE YASS_APP_SUBTAG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    ERROR_QUIET)
  set(_ABBREV_REF "${YASS_APP_TAG}\{${YASS_APP_SUBTAG}\}")

  set(YASS_APP_LAST_CHANGE "${_LAST_CHANGE_REF}-refs/branch-heads/${_ABBREV_REF}")
else()
  # read if running from tarball
  file(READ ${CMAKE_CURRENT_SOURCE_DIR}/LAST_CHANGE YASS_APP_LAST_CHANGE)
  file(READ ${CMAKE_CURRENT_SOURCE_DIR}/TAG YASS_APP_TAG)
  file(READ ${CMAKE_CURRENT_SOURCE_DIR}/SUBTAG YASS_APP_SUBTAG)
endif()

set(_YASS_VERSION ${YASS_APP_TAG})

set(_YASS_VERSION_MAJOR     1)
set(_YASS_VERSION_MINOR     3)
set(_YASS_VERSION_PATCH     0)
set(_YASS_VERSION_TWEAK     0)
string(REPLACE "-" "." _YASS_VERSION_SPLIT ${_YASS_VERSION})
string(REPLACE "." ";" _YASS_VERSION_SPLIT ${_YASS_VERSION_SPLIT})
list(GET _YASS_VERSION_SPLIT 0 _YASS_VERSION_MAJOR)
list(GET _YASS_VERSION_SPLIT 1 _YASS_VERSION_MINOR)
list(GET _YASS_VERSION_SPLIT 2 _YASS_VERSION_PATCH)
set(_YASS_VERSION_TWEAK     ${YASS_APP_SUBTAG})

set(PACKAGE_NAME            "yass")
set(PACKAGE_FULL_NAME       "Yet Another Shadow Socket")
set(PACKAGE_VERSION_MAJOR ${_YASS_VERSION_MAJOR})
set(PACKAGE_VERSION_MINOR ${_YASS_VERSION_MINOR})
set(PACKAGE_VERSION_PATCH ${_YASS_VERSION_PATCH})
set(PACKAGE_VERSION_TWEAK ${_YASS_VERSION_TWEAK})
set(PACKAGE_VERSION ${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_PATCH})

# Defer enabling C and CXX languages.
project(${PACKAGE_NAME} NONE)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Set variables used in configure_file
set(YASS_APP_NAME ${PACKAGE_NAME})
set(YASS_APP_FULL_NAME ${PACKAGE_FULL_NAME})
set(YASS_APP_INTERNAL_NAME ${PACKAGE_NAME}_gui)
set(YASS_APP_WEBSITE "https://github.com/Chilledheart/yass")
set(YASS_APP_VERSION ${PACKAGE_VERSION})
set(YASS_APP_VERSION_MAJOR ${PACKAGE_VERSION_MAJOR})
set(YASS_APP_VERSION_MINOR ${PACKAGE_VERSION_MINOR})
set(YASS_APP_VERSION_PATCH ${PACKAGE_VERSION_PATCH})
set(YASS_APP_VERSION_TWEAK ${PACKAGE_VERSION_TWEAK})
set(YASS_APP_FULL_VERSION ${PACKAGE_VERSION}.${PACKAGE_VERSION_TWEAK})
set(YASS_APP_COPYRIGHT "Copyright 2019-2026 Chilledheart. All rights reserved.")

message(STATUS "Source Tag: ${YASS_APP_TAG}-${YASS_APP_SUBTAG}")
message(STATUS "Source LastChange: ${YASS_APP_LAST_CHANGE}")

set(APP_VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/version.h")
configure_file("src/version.h.in" "${APP_VERSION_HEADER}" @ONLY)
# for version.h
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(YASS_APP_FEATURES)

option(OFFICIAL_BUILD "Build with official build" OFF)

if (OFFICIAL_BUILD)
  list(APPEND YASS_APP_FEATURES "official-build")
  add_compile_definitions(-DOFFICIAL_BUILD)
endif()

if(MSVC)
  # On Windows, prefer cl over gcc if both are available. By default most of
  # the CMake generators prefer gcc, even on Windows.
  set(CMAKE_GENERATOR_CC cl)

  # new in cmake 3.10
  # https://cmake.org/cmake/help/latest/variable/CMAKE_LANG_COMPILER_ARCHITECTURE_ID.html
  # not used in ABI-detection due to the cmake issue https://gitlab.kitware.com/cmake/cmake/-/issues/17702
  set(CMAKE_C_COMPILER_ARCHITECTURE_ID "${CMAKE_C_COMPILER_TARGET}" CACHE STRING "")
  set(CMAKE_CXX_COMPILER_ARCHITECTURE_ID "${CMAKE_CXX_COMPILER_TARGET}" CACHE STRING "")
endif()

if (APPLE AND NOT IOS AND NOT CMAKE_OSX_DEPLOYMENT_TARGET)
  if (USE_LIBCXX)
    set(CMAKE_OSX_DEPLOYMENT_TARGET "10.14")
  else()
    set(CMAKE_OSX_DEPLOYMENT_TARGET "10.15")
  endif()
endif()

if (APPLE AND NOT CMAKE_OSX_ARCHITECTURES)
  set(CMAKE_OSX_ARCHITECTURES ${CMAKE_SYSTEM_PROCESSOR})
endif()

enable_language(C)
enable_language(CXX)

# required by zstd
if (NOT COMPILER_MSVC)
  enable_language(ASM)
endif()

## Setup compiler informations
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
  set(COMPILER_CLANG TRUE)
else()
  set(COMPILER_CLANG FALSE)
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
  set(COMPILER_APPLE_CLANG TRUE)
endif()

if (${CMAKE_GENERATOR} MATCHES "^Xcode.*")
  set(COMPILER_APPLE_CLANG TRUE)
endif()

if (COMPILER_CLANG AND NOT CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 5.0)
  message(FATAL_ERROR "Requires Clang 5.0 or newer to compile")
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set(COMPILER_GCC TRUE)
else()
  set(COMPILER_GCC FALSE)
endif()

if (COMPILER_GCC AND NOT CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 7.1)
  message(FATAL_ERROR "Requires GCC 7.1 or newer to compile")
endif()

if (MSVC AND NOT COMPILER_CLANG)
  set(COMPILER_MSVC TRUE)
else()
  set(COMPILER_MSVC FALSE)
endif()

if (COMPILER_MSVC)
  message(FATAL_ERROR "Only clang-cl is supported on Windows, see https://crbug.com/988071")
endif()

if((${CMAKE_LINKER} MATCHES "lld") AND (${CMAKE_AR} MATCHES "llvm-lib" OR ${CMAKE_AR} MATCHES "llvm-ar"))
  set(LINKER_LLD TRUE)
else()
  set(LINKER_LLD FALSE)
endif()

if (MSVC)
  if("${MSVC_C_ARCHITECTURE_ID}" STREQUAL "X86")
    set(MSVC_PROCESSOR_ARCHITECTURE "x86")
  elseif("${MSVC_C_ARCHITECTURE_ID}" STREQUAL "x64")
    set(MSVC_PROCESSOR_ARCHITECTURE "amd64")
  elseif("${MSVC_C_ARCHITECTURE_ID}" STREQUAL "ARM")
    set(MSVC_PROCESSOR_ARCHITECTURE "arm")
  elseif("${MSVC_C_ARCHITECTURE_ID}" STREQUAL "ARM64")
    set(MSVC_PROCESSOR_ARCHITECTURE "arm64")
  else()
    message(FATAL_ERROR "Failed to determine the MSVC target architecture: ${MSVC_C_ARCHITECTURE_ID}")
  endif()
endif()

if (IOS)
  list(APPEND YASS_APP_FEATURES "${SDK_NAME} ${DEPLOYMENT_TARGET}")
elseif(APPLE)
  list(APPEND YASS_APP_FEATURES "mac ${CMAKE_OSX_DEPLOYMENT_TARGET}")
elseif(OHOS)
  list(APPEND YASS_APP_FEATURES "harmony ${OHOS_APILEVEL}")
elseif(ANDROID)
  list(APPEND YASS_APP_FEATURES "android ${ANDROID_API_VERSION}")
elseif(MSVC)
  list(APPEND YASS_APP_FEATURES "msvc")
elseif(MINGW)
  list(APPEND YASS_APP_FEATURES "mingw")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  list(APPEND YASS_APP_FEATURES "linux")
elseif(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  if (NOT CMAKE_CROSSCOMPILING)
    execute_process(COMMAND
      uname -r
      OUTPUT_VARIABLE _ABI_VERSION_STRING
      OUTPUT_STRIP_TRAILING_WHITESPACE)
    string(REGEX REPLACE "([0-9]+)\.[0-9]-.*" "\\1" FREEBSD_ABI_VERSION "${_ABI_VERSION_STRING}")
  endif()

  if (FREEBSD_ABI_VERSION)
    list(APPEND YASS_APP_FEATURES "freebsd ${FREEBSD_ABI_VERSION}")
  else()
    list(APPEND YASS_APP_FEATURES "freebsd unknown")
  endif()
else()
  list(APPEND YASS_APP_FEATURES "${CMAKE_SYSTEM_NAME}")
endif()

if (MSVC)
  message(STATUS "Build with MSVC target architecture: ${MSVC_PROCESSOR_ARCHITECTURE}")
  message(STATUS "Build with MSVC ${MSVC_CRT_LINKAGE} CRT library")
  if (MSVC_PROCESSOR_ARCHITECTURE STREQUAL "x86")
    set(OS_X86 TRUE)
  endif()
  if (MSVC_PROCESSOR_ARCHITECTURE STREQUAL "amd64")
    set(OS_X64 TRUE)
  endif()
  if (MSVC_PROCESSOR_ARCHITECTURE STREQUAL "arm64")
    set(OS_AARCH64 TRUE)
  endif()
  list(APPEND YASS_APP_FEATURES "arch: ${MSVC_PROCESSOR_ARCHITECTURE}")
  list(APPEND YASS_APP_FEATURES "${MSVC_CRT_LINKAGE} crt")
elseif(APPLE)
  message(STATUS "Build with target architecture: ${CMAKE_OSX_ARCHITECTURES}")
  list(LENGTH CMAKE_OSX_ARCHITECTURES OSX_CROSS_ARCHITECTURES_COUNT)
  if (OSX_CROSS_ARCHITECTURES_COUNT EQUAL 1 AND CMAKE_OSX_ARCHITECTURES STREQUAL "x86_64")
    set(OS_X64 TRUE)
  elseif (OSX_CROSS_ARCHITECTURES_COUNT EQUAL 0 AND CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
    set(OS_X64 TRUE)
  endif()
  if (OSX_CROSS_ARCHITECTURES_COUNT EQUAL 1 AND CMAKE_OSX_ARCHITECTURES STREQUAL "arm64")
    set(OS_AARCH64 TRUE)
  elseif (OSX_CROSS_ARCHITECTURES_COUNT EQUAL 0 AND CMAKE_SYSTEM_PROCESSOR STREQUAL "arm64")
    set(OS_AARCH64 TRUE)
  endif()
  list(APPEND YASS_APP_FEATURES "arch: ${CMAKE_OSX_ARCHITECTURES}")
else()
  # x86
  if (CMAKE_C_COMPILER_TARGET MATCHES "^i.86-.*")
    set(OS_X86 TRUE)
  endif()
  if (NOT CMAKE_C_COMPILER_TARGET AND CMAKE_SYSTEM_PROCESSOR MATCHES "^i.86$")
    set(OS_X86 TRUE)
  endif()

  # x64
  if ((CMAKE_C_COMPILER_TARGET MATCHES "^amd64*" OR
       CMAKE_C_COMPILER_TARGET MATCHES "^x86_64*" OR
       CMAKE_C_COMPILER_TARGET MATCHES "^x64*"))
    set(OS_X64 TRUE)
  endif()
  if (NOT CMAKE_C_COMPILER_TARGET AND
      (CMAKE_SYSTEM_PROCESSOR MATCHES "^amd64$" OR
       CMAKE_SYSTEM_PROCESSOR MATCHES "^x86_64$" OR
       CMAKE_SYSTEM_PROCESSOR MATCHES "^x64$"))
    set(OS_X64 TRUE)
  endif()

  # arm
  if (CMAKE_C_COMPILER_TARGET MATCHES "^arm-.*")
    set(OS_ARM TRUE)
  endif()
  if (NOT CMAKE_C_COMPILER_TARGET AND
      (CMAKE_SYSTEM_PROCESSOR MATCHES "^arm$" OR
       CMAKE_SYSTEM_PROCESSOR MATCHES "^armel$" OR
       CMAKE_SYSTEM_PROCESSOR MATCHES "^armhf$"))
    set(OS_ARM TRUE)
  endif()

  # arm64
  if ((CMAKE_C_COMPILER_TARGET MATCHES "^arm64-.*" OR
       CMAKE_C_COMPILER_TARGET MATCHES "^aarch64-.*"))
    set(OS_AARCH64 TRUE)
  endif()
  if (NOT CMAKE_C_COMPILER_TARGET AND
      (CMAKE_SYSTEM_PROCESSOR MATCHES "^arm64$" OR
       CMAKE_SYSTEM_PROCESSOR MATCHES "^aarch64$"))
    set(OS_AARCH64 TRUE)
  endif()

  # mips
  if ((CMAKE_C_COMPILER_TARGET MATCHES "^mipsel-.*" OR
       CMAKE_C_COMPILER_TARGET MATCHES "^mips-.*"))
    set(OS_MIPS TRUE)

=== Makefile ===
SRC_DIR := src
SRC_FILES := $(wildcard $(SRC_DIR)/*.mm)
SRC_FILES := $(wildcard $(SRC_DIR)/*.cc)
SRC_FILES := $(wildcard $(SRC_DIR)/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/android/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/android/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/cli/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/cli/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/config/*.mm)
SRC_FILES += $(wildcard $(SRC_DIR)/config/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/config/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/core/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/core/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/crypto/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/crypto/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/freedesktop/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/freedesktop/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk/*.c)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk4/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/gtk4/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/qt6/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/qt6/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/harmony/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/harmony/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/i18n/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/i18n/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/*.mm)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/*.h)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/extensions/*.mm)
SRC_FILES += $(wildcard $(SRC_DIR)/ios/extensions/*.h)
SRC_FILES += $(wildcard $(SRC_DIR)/mac/*.mm)
SRC_FILES += $(wildcard $(SRC_DIR)/mac/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/mac/*.h)
SRC_FILES += $(wildcard $(SRC_DIR)/net/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/net/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/server/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/server/*.hpp)
SRC_FILES += $(wildcard $(SRC_DIR)/win32/*.cpp)
SRC_FILES += $(wildcard $(SRC_DIR)/win32/*.hpp)
all: $(SRC_FILES)
	clang-format --style file -i $(SRC_FILES)

=== doc/Makefile ===
MANS = yass_cli.1 yass_server.1

%.1: %.md
	ronn $< -o .

all: $(MANS)

clean:
	rm -vf *.1

=== harmony/Makefile ===
all:
	mkdir -p entry/libs/arm64-v8a entry/libs/armeabi-v7a entry/libs/x86_64
	cd ../build-harmony-arm64 && rm -f libyass.so && cd ..
	cd ../build-harmony-arm64 && ninja yass && cd ..
	cd ../build-harmony-arm64 && ../third_party/llvm-build/Release+Asserts/bin/llvm-objcopy --only-keep-debug libyass.so libyass.so.dbg && cd ..
	cd ../build-harmony-arm64 && ../third_party/llvm-build/Release+Asserts/bin/llvm-objcopy --strip-debug libyass.so && cd ..
	cd ../build-harmony-arm64 && ../third_party/llvm-build/Release+Asserts/bin/llvm-objcopy --add-gnu-debuglink=libyass.so.dbg libyass.so && cd ..
	cp -v ../build-harmony-arm64/libyass.so entry/libs/arm64-v8a
	cd ../build-harmony-arm && rm -f libyass.so && cd ..
	cd ../build-harmony-arm && ninja yass && cd ..
	cd ../build-harmony-arm && ../third_party/llvm-build/Release+Asserts/bin/llvm-objcopy --only-keep-debug libyass.so libyass.so.dbg && cd ..
	cd ../build-harmony-arm && ../third_party/llvm-build/Release+Asserts/bin/llvm-objcopy --strip-debug libyass.so && cd ..
	cd ../build-harmony-arm && ../third_party/llvm-build/Release+Asserts/bin/llvm-objcopy --add-gnu-debuglink=libyass.so.dbg libyass.so && cd ..
	cp -v ../build-harmony-arm/libyass.so entry/libs/armeabi-v7a
	cd ../build-harmony-x64 && rm -f libyass.so && cd ..
	cd ../build-harmony-x64 && ninja yass && cd ..
	cd ../build-harmony-x64 && ../third_party/llvm-build/Release+Asserts/bin/llvm-objcopy --only-keep-debug libyass.so libyass.so.dbg && cd ..
	cd ../build-harmony-x64 && ../third_party/llvm-build/Release+Asserts/bin/llvm-objcopy --strip-debug libyass.so && cd ..
	cd ../build-harmony-x64 && ../third_party/llvm-build/Release+Asserts/bin/llvm-objcopy --add-gnu-debuglink=libyass.so.dbg libyass.so && cd ..
	cp -v ../build-harmony-x64/libyass.so entry/libs/x86_64

clean:
	rm -rf entry/libs

=== third_party/CMakeLists.txt ===
# *****************************************************************************************
#           re2 Library
# *****************************************************************************************
# build re2 required by absl
set(RE2_SOURCES
  re2/re2/bitmap256.cc
  re2/re2/bitstate.cc
  re2/re2/compile.cc
  re2/re2/dfa.cc
  re2/re2/filtered_re2.cc
  re2/re2/mimics_pcre.cc
  re2/re2/nfa.cc
  re2/re2/onepass.cc
  re2/re2/parse.cc
  re2/re2/perl_groups.cc
  re2/re2/prefilter.cc
  re2/re2/prefilter_tree.cc
  re2/re2/prog.cc
  re2/re2/re2.cc
  re2/re2/regexp.cc
  re2/re2/set.cc
  re2/re2/simplify.cc
  re2/re2/tostring.cc
  re2/re2/unicode_casefold.cc
  re2/re2/unicode_groups.cc
  re2/util/rune.cc
  re2/util/strutil.cc
  )

set(RE2_HEADERS
  re2/re2/filtered_re2.h
  re2/re2/re2.h
  re2/re2/set.h
  re2/re2/stringpiece.h
  )

add_library(re2 ${RE2_SOURCES} ${RE2_HEADERS})
if (USE_LTO_CMAKE)
  set_property(TARGET re2
    PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
endif()
target_include_directories(re2 PUBLIC re2)

target_link_libraries(re2 PUBLIC
  absl::absl_check
  absl::absl_log
  absl::base
  absl::core_headers
  absl::fixed_array
  absl::flags
  absl::flat_hash_map
  absl::flat_hash_set
  absl::hash
  absl::inlined_vector
  absl::optional
  absl::span
  absl::str_format
  absl::strings
  absl::synchronization
  )

if (USE_ICU)
  target_compile_definitions(re2 PRIVATE RE2_USE_ICU)
  target_link_libraries(re2 PRIVATE icuuc)
endif()

add_library(re2::re2 ALIAS re2)

# *****************************************************************************************
#           googleurl Library
# *****************************************************************************************

add_library(url STATIC
  # polyfills
  googleurl/polyfills/base/allocator/buildflags.h
  googleurl/polyfills/base/base_export.h
  googleurl/polyfills/base/check.h
  googleurl/polyfills/base/check_op.h
  googleurl/polyfills/base/component_export.h
  googleurl/polyfills/base/cpu_reduction_experiment.h
  googleurl/polyfills/base/dcheck_is_on.h
  googleurl/polyfills/base/debug/alias.h
  googleurl/polyfills/base/export_template.h
  googleurl/polyfills/base/feature_list.h
  googleurl/polyfills/base/logging.h
  googleurl/polyfills/base/memory/raw_ptr.h
  googleurl/polyfills/base/metrics/histogram_macros.h
  googleurl/polyfills/base/notreached.h
  googleurl/polyfills/base/trace_event/memory_usage_estimator.h
  # base
  googleurl/base/bits.h
  googleurl/base/compiler_specific.h
  googleurl/base/containers/checked_iterators.h
  googleurl/base/containers/contains.h
  googleurl/base/containers/contiguous_iterator.h
  googleurl/base/containers/span.h
  googleurl/base/containers/util.h
  googleurl/base/cxx20_is_constant_evaluated.h
  googleurl/base/debug/crash_logging.h
  googleurl/base/debug/leak_annotations.h
  googleurl/base/functional/identity.h
  googleurl/base/functional/invoke.h
  googleurl/base/functional/not_fn.h
  #googleurl/base/memory/raw_ptr_exclusion.h
  googleurl/base/no_destructor.h
  googleurl/base/numerics/checked_math.h
  googleurl/base/numerics/checked_math_impl.h
  googleurl/base/numerics/clamped_math.h
  googleurl/base/numerics/clamped_math_impl.h
  googleurl/base/numerics/safe_conversions.h
  googleurl/base/numerics/safe_conversions_arm_impl.h
  googleurl/base/numerics/safe_conversions_impl.h
  googleurl/base/numerics/safe_math.h
  googleurl/base/numerics/safe_math_arm_impl.h
  googleurl/base/numerics/safe_math_clang_gcc_impl.h
  googleurl/base/numerics/safe_math_shared_impl.h
  googleurl/base/ranges/algorithm.h
  googleurl/base/ranges/functional.h
  googleurl/base/ranges/ranges.h
  googleurl/base/stl_util.h
  googleurl/base/template_util.h
  googleurl/base/types/supports_ostream_operator.h
  googleurl/base/strings/string_piece.h
  googleurl/base/strings/to_string.h
  googleurl/base/strings/string_util_impl_helpers.h
  googleurl/base/strings/string_util_internal.h
  googleurl/base/strings/string_number_conversions.h
  googleurl/base/strings/string_number_conversions.cc
  googleurl/base/strings/string_number_conversions_win.cc
  googleurl/base/strings/utf_ostream_operators.h
  googleurl/base/strings/utf_string_conversions.h
  googleurl/base/strings/utf_string_conversion_utils.h
  googleurl/base/win/win_handle_types.h
  googleurl/base/debug/crash_logging.cc
  googleurl/base/strings/string_util.h
  googleurl/base/strings/string_util.cc
  googleurl/base/strings/string_util_constants.cc
  # FIXME vs2022 doesn't even compile
  googleurl/base/strings/utf_ostream_operators.cc
  googleurl/base/strings/utf_string_conversion_utils.cc
  googleurl/base/strings/utf_string_conversions.cc
  # icu
  googleurl/base/third_party/icu/icu_utf.h
  # url
  googleurl/url/gurl.cc
  googleurl/url/third_party/mozilla/url_parse.cc
  googleurl/url/url_canon.cc
  googleurl/url/url_canon_etc.cc
  googleurl/url/url_canon_filesystemurl.cc
  googleurl/url/url_canon_fileurl.cc
  googleurl/url/url_canon_host.cc
  googleurl/url/url_canon_internal.cc
  googleurl/url/url_canon_internal.h
  googleurl/url/url_canon_internal_file.h
  googleurl/url/url_canon_ip.cc
  googleurl/url/url_canon_mailtourl.cc
  googleurl/url/url_canon_path.cc
  googleurl/url/url_canon_pathurl.cc
  googleurl/url/url_canon_query.cc
  googleurl/url/url_canon_relative.cc
  googleurl/url/url_canon_stdstring.cc
  googleurl/url/url_canon_stdurl.cc
  googleurl/url/url_constants.cc
  googleurl/url/url_features.cc
  googleurl/url/url_parse_file.cc
  googleurl/url/url_parse_internal.h
  googleurl/url/url_util.cc
  googleurl/url/url_util_internal.h
  googleurl/base/pickle.h
  googleurl/base/pickle.cc
  # googleurl/url/scheme_host_port.cc
  # googleurl/url/scheme_host_port.h
  # googleurl/url/origin.cc
  # googleurl/url/origin.h
  googleurl/base/atomic_ref_count.h
  googleurl/base/atomicops.h
  googleurl/base/atomicops_internals_portable.h
  googleurl/base/atomicops_internals_atomicword_compat.h
  googleurl/base/files/file_util.h
  googleurl/base/macros/concat.h
  googleurl/base/macros/if.h
  googleurl/base/macros/remove_parens.h
  googleurl/base/macros/uniquify.h
  googleurl/base/memory/raw_ptr_exclusion.h
  googleurl/base/memory/ref_counted.cc
  googleurl/base/memory/ref_counted.h
  googleurl/base/memory/scoped_refptr.h
  googleurl/base/process/process_handle.h
  googleurl/base/threading/platform_thread.cc
  googleurl/base/threading/platform_thread.h
  googleurl/base/threading/thread_collision_warner.cc
  googleurl/base/threading/thread_collision_warner.h
  googleurl/base/rand_util.h
  googleurl/base/rand_util.cc
  googleurl/polyfills/base/logging.h
  googleurl/polyfills/base/logging.cc
  googleurl/polyfills/base/check.h
  googleurl/polyfills/base/check.cc
  googleurl/polyfills/base/check_op.h
  googleurl/polyfills/base/check_op.cc
  googleurl/polyfills/base/debug/alias.h
  googleurl/polyfills/base/debug/alias.cc
  googleurl/polyfills/base/debug/debugger.h
  googleurl/polyfills/base/debug/debugger.cc
  )

if (WIN32)
  target_sources(url PRIVATE
    googleurl/base/strings/sys_string_conversions_win.cc)

  target_sources(url PRIVATE
    googleurl/base/files/file_util_win.cc
    googleurl/base/strings/string_util_win.h
    googleurl/base/strings/string_util_win.cc)
elseif(APPLE)
  target_sources(url PRIVATE
    googleurl/base/apple/scoped_cftyperef.h
    googleurl/base/apple/scoped_typeref.h
    googleurl/base/apple/foundation_util.mm
    googleurl/base/apple/foundation_util.h
    googleurl/base/files/file_util_apple.mm
    googleurl/base/mac/scoped_ioobject.h
    googleurl/base/strings/sys_string_conversions_apple.mm
  )
  # missing apple part
else()
  target_sources(url PRIVATE
    googleurl/base/files/file_util_posix.cc
    googleurl/base/strings/sys_string_conversions_posix.cc)
endif()

if (WIN32)
  target_sources(url PRIVATE
    googleurl/polyfills/base/debug/debugger_win.cc
    googleurl/base/process/process_handle_win.cc
    googleurl/base/scoped_clear_last_error_win.cc
    googleurl/base/rand_util_win.cc)
else()
  target_sources(url PRIVATE
    googleurl/polyfills/base/debug/debugger_posix.cc
    googleurl/base/process/process_handle_posix.cc
    googleurl/base/posix/safe_strerror.cc
    googleurl/base/posix/safe_strerror.h
    googleurl/base/rand_util_posix.cc)
endif()

if (USE_ICU)
  target_sources(url PRIVATE
    googleurl/url/url_idna_icu.cc
    googleurl/url/url_canon_icu.h
  )
  target_link_libraries(url PRIVATE
    icuuc
  )
else()
  target_sources(url PRIVATE
    googleurl/url/url_idna_ascii_only.cc
  )
endif()

add_library(double_conversion STATIC
  googleurl/base/third_party/double_conversion/double-conversion/bignum-dtoa.cc
  googleurl/base/third_party/double_conversion/double-conversion/bignum-dtoa.h
  googleurl/base/third_party/double_conversion/double-conversion/bignum.cc
  googleurl/base/third_party/double_conversion/double-conversion/bignum.h
  googleurl/base/third_party/double_conversion/double-conversion/cached-powers.cc
  googleurl/base/third_party/double_conversion/double-conversion/cached-powers.h
  googleurl/base/third_party/double_conversion/double-conversion/diy-fp.h
  googleurl/base/third_party/double_conversion/double-conversion/double-to-string.cc
  googleurl/base/third_party/double_conversion/double-conversion/double-to-string.h
  googleurl/base/third_party/double_conversion/double-conversion/double-conversion.h
  googleurl/base/third_party/double_conversion/double-conversion/fast-dtoa.cc
  googleurl/base/third_party/double_conversion/double-conversion/fast-dtoa.h
  googleurl/base/third_party/double_conversion/double-conversion/fixed-dtoa.cc
  googleurl/base/third_party/double_conversion/double-conversion/fixed-dtoa.h
  googleurl/base/third_party/double_conversion/double-conversion/ieee.h
  googleurl/base/third_party/double_conversion/double-conversion/string-to-double.cc
  googleurl/base/third_party/double_conversion/double-conversion/string-to-double.h
  googleurl/base/third_party/double_conversion/double-conversion/strtod.cc
  googleurl/base/third_party/double_conversion/double-conversion/strtod.h
  googleurl/base/third_party/double_conversion/double-conversion/utils.h
)

if (USE_LTO_CMAKE)
  set_property(TARGET double_conversion
    PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
endif()

target_include_directories(double_conversion PRIVATE
  googleurl/base/third_party/double_conversion/double-conversion
)

target_compile_options(double_conversion PRIVATE -Wno-unused-const-variable -Wno-unused-function)

target_link_libraries(url PUBLIC double_conversion)

if (USE_LTO_CMAKE)
  set_property(TARGET url
    PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
endif()

target_include_directories(url PUBLIC
  googleurl/polyfills
  googleurl
  ${CMAKE_CURRENT_SOURCE_DIR}/..
  )

target_link_libraries(url PUBLIC absl::optional)

target_sources(url PRIVATE
  googleurl/base/files/memory_mapped_file.h
  googleurl/base/files/memory_mapped_file.cc
  googleurl/base/location.h
  googleurl/base/location.cc
)
if (WIN32)
  target_sources(url PRIVATE
    googleurl/base/win/pe_image.cc
    googleurl/base/win/pe_image.h
    googleurl/base/win/scoped_handle.cc
    googleurl/base/win/scoped_handle.h
    googleurl/base/win/windows_types.h
    googleurl/base/win/win_handle_types.h
    googleurl/base/files/memory_mapped_file_win.cc
  )
  target_link_libraries(url PRIVATE delayimp)
else()
  target_sources(url PRIVATE
    googleurl/base/files/memory_mapped_file_posix.cc
  )
endif()

=== src/gtk/Makefile ===
SRC := $(wildcard *.cpp)
PO_FILES := $(wildcard *.po)

TEMPLATE_PO := messages.po.tmp

.PHONY: all clean

all: $(PO_FILES)

$(TEMPLATE_PO): $(SRC)
	xgettext -k_ -o $@ $^
	sed -i s/CHARSET/UTF-8/g $@

%.po: $(TEMPLATE_PO)
	$(eval TMP := $(shell mktemp))
	msgmerge -N --previous $@ $< > $(TMP)
	mv -f $(TMP) $@

clean:
	-rm -f $(TEMPLATE_PO)

=== src/gtk4/Makefile ===
SRC := $(wildcard *.cpp) $(wildcard *.ui)
PO_FILES := $(wildcard *.po)

TEMPLATE_PO := messages.po.tmp

.PHONY: all clean

all: $(PO_FILES)

$(TEMPLATE_PO): $(SRC)
	xgettext -k_ -o $@ $^
	sed -i s/CHARSET/UTF-8/g $@

%.po: $(TEMPLATE_PO)
	$(eval TMP := $(shell mktemp))
	msgmerge -N --previous $@ $< > $(TMP)
	mv -f $(TMP) $@

clean:
	-rm -f $(TEMPLATE_PO)

=== src/qt6/Makefile ===
# use make -B update-qm to update all qm files
QT_DIR ?= /usr/lib/qt6
LUPDATE := $(QT_DIR)/bin/lupdate
LRELEASE := $(QT_DIR)/bin/lrelease

ifeq ("$(VERBOSE)","1")
	Q :=
else
	Q := -silent
endif

SRC := $(wildcard *.cc) $(wildcard *.cpp) $(wildcard *.hpp)
TARGET_TS := $(wildcard lang/yass_*.ts)
TARGET_QMS := $(TARGET_TS:.ts=.qm)
PWD := $(shell pwd)
PARENT_DIR := $(dir $(PWD))

.PHONY: all update-ts update-qm

all: update-qm update-ts

update-ts: $(TARGET_TS)

%.ts: $(SRC)
	$(LUPDATE) -extensions cc,cpp,hpp $(Q) -locations none -I $(PARENT_DIR) $(PWD) -ts $@

update-qm: $(TARGET_QMS)

%.qm: %.ts
	$(LRELEASE) -removeidentical $(Q) $^ $@

=== third_party/benchmark/CMakeLists.txt ===
# Require CMake 3.10. If available, use the policies up to CMake 3.22.
cmake_minimum_required (VERSION 3.10...3.22)

project (benchmark VERSION 1.9.0 LANGUAGES CXX)

option(BENCHMARK_ENABLE_TESTING "Enable testing of the benchmark library." ON)
option(BENCHMARK_ENABLE_EXCEPTIONS "Enable the use of exceptions in the benchmark library." ON)
option(BENCHMARK_ENABLE_LTO "Enable link time optimisation of the benchmark library." OFF)
option(BENCHMARK_USE_LIBCXX "Build and test using libc++ as the standard library." OFF)
option(BENCHMARK_ENABLE_WERROR "Build Release candidates with -Werror." ON)
option(BENCHMARK_FORCE_WERROR "Build Release candidates with -Werror regardless of compiler issues." OFF)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "PGI")
  # PGC++ maybe reporting false positives.
  set(BENCHMARK_ENABLE_WERROR OFF)
endif()
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "NVHPC")
  set(BENCHMARK_ENABLE_WERROR OFF)
endif()
if(BENCHMARK_FORCE_WERROR)
  set(BENCHMARK_ENABLE_WERROR ON)
endif(BENCHMARK_FORCE_WERROR)

if(NOT (MSVC OR CMAKE_CXX_SIMULATE_ID STREQUAL "MSVC"))
  option(BENCHMARK_BUILD_32_BITS "Build a 32 bit version of the library." OFF)
else()
  set(BENCHMARK_BUILD_32_BITS OFF CACHE BOOL "Build a 32 bit version of the library - unsupported when using MSVC)" FORCE)
endif()
option(BENCHMARK_ENABLE_INSTALL "Enable installation of benchmark. (Projects embedding benchmark may want to turn this OFF.)" ON)
option(BENCHMARK_ENABLE_DOXYGEN "Build documentation with Doxygen." OFF)
option(BENCHMARK_INSTALL_DOCS "Enable installation of documentation." ON)

# Allow unmet dependencies to be met using CMake's ExternalProject mechanics, which
# may require downloading the source code.
option(BENCHMARK_DOWNLOAD_DEPENDENCIES "Allow the downloading and in-tree building of unmet dependencies" OFF)

# This option can be used to disable building and running unit tests which depend on gtest
# in cases where it is not possible to build or find a valid version of gtest.
option(BENCHMARK_ENABLE_GTEST_TESTS "Enable building the unit tests which depend on gtest" ON)
option(BENCHMARK_USE_BUNDLED_GTEST "Use bundled GoogleTest. If disabled, the find_package(GTest) will be used." ON)

option(BENCHMARK_ENABLE_LIBPFM "Enable performance counters provided by libpfm" OFF)

# Export only public symbols
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

if(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    # As of CMake 3.18, CMAKE_SYSTEM_PROCESSOR is not set properly for MSVC and
    # cross-compilation (e.g. Host=x86_64, target=aarch64) requires using the
    # undocumented, but working variable.
    # See https://gitlab.kitware.com/cmake/cmake/-/issues/15170
    set(CMAKE_SYSTEM_PROCESSOR ${MSVC_CXX_ARCHITECTURE_ID})
    if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "ARM")
      set(CMAKE_CROSSCOMPILING TRUE)
    endif()
endif()

set(ENABLE_ASSEMBLY_TESTS_DEFAULT OFF)
function(should_enable_assembly_tests)
  if(CMAKE_BUILD_TYPE)
    string(TOLOWER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE_LOWER)
    if (${CMAKE_BUILD_TYPE_LOWER} MATCHES "coverage")
      # FIXME: The --coverage flag needs to be removed when building assembly
      # tests for this to work.
      return()
    endif()
  endif()
  if (MSVC OR CMAKE_CXX_SIMULATE_ID STREQUAL "MSVC")
    return()
  elseif(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
    return()
  elseif(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    # FIXME: Make these work on 32 bit builds
    return()
  elseif(BENCHMARK_BUILD_32_BITS)
     # FIXME: Make these work on 32 bit builds
    return()
  endif()
  find_program(LLVM_FILECHECK_EXE FileCheck)
  if (LLVM_FILECHECK_EXE)
    set(LLVM_FILECHECK_EXE "${LLVM_FILECHECK_EXE}" CACHE PATH "llvm filecheck" FORCE)
    message(STATUS "LLVM FileCheck Found: ${LLVM_FILECHECK_EXE}")
  else()
    message(STATUS "Failed to find LLVM FileCheck")
    return()
  endif()
  set(ENABLE_ASSEMBLY_TESTS_DEFAULT ON PARENT_SCOPE)
endfunction()
should_enable_assembly_tests()

# This option disables the building and running of the assembly verification tests
option(BENCHMARK_ENABLE_ASSEMBLY_TESTS "Enable building and running the assembly tests"
    ${ENABLE_ASSEMBLY_TESTS_DEFAULT})

# Make sure we can import out CMake functions
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")


# Read the git tags to determine the project version
include(GetGitVersion)
get_git_version(GIT_VERSION)

# If no git version can be determined, use the version
# from the project() command
if ("${GIT_VERSION}" STREQUAL "v0.0.0")
  set(VERSION "v${benchmark_VERSION}")
else()
  set(VERSION "${GIT_VERSION}")
endif()

# Normalize version: drop "v" prefix, replace first "-" with ".",
# drop everything after second "-" (including said "-").
string(STRIP ${VERSION} VERSION)
if(VERSION MATCHES v[^-]*-)
   string(REGEX REPLACE "v([^-]*)-([0-9]+)-.*" "\\1.\\2"  NORMALIZED_VERSION ${VERSION})
else()
   string(REGEX REPLACE "v(.*)" "\\1" NORMALIZED_VERSION ${VERSION})
endif()

# Tell the user what versions we are using
message(STATUS "Google Benchmark version: ${VERSION}, normalized to ${NORMALIZED_VERSION}")

# The version of the libraries
set(GENERIC_LIB_VERSION ${NORMALIZED_VERSION})
string(SUBSTRING ${NORMALIZED_VERSION} 0 1 GENERIC_LIB_SOVERSION)

# Import our CMake modules
include(AddCXXCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckLibraryExists)
include(CXXFeatureCheck)

check_library_exists(rt shm_open "" HAVE_LIB_RT)

if (BENCHMARK_BUILD_32_BITS)
  add_required_cxx_compiler_flag(-m32)
endif()

set(BENCHMARK_CXX_STANDARD 14)

set(CMAKE_CXX_STANDARD ${BENCHMARK_CXX_STANDARD})
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS OFF)

if (MSVC)
  # Turn compiler warnings up to 11
  string(REGEX REPLACE "[-/]W[1-4]" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)

  if (NOT BENCHMARK_ENABLE_EXCEPTIONS)
    add_cxx_compiler_flag(-EHs-)
    add_cxx_compiler_flag(-EHa-)
    add_definitions(-D_HAS_EXCEPTIONS=0)
  endif()
  # Link time optimisation
  if (BENCHMARK_ENABLE_LTO)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /GL")
    set(CMAKE_STATIC_LINKER_FLAGS_RELEASE "${CMAKE_STATIC_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /LTCG")
    set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /LTCG")

    set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /GL")
    string(REGEX REPLACE "[-/]INCREMENTAL" "/INCREMENTAL:NO" CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO}")
    set(CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_STATIC_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")
    string(REGEX REPLACE "[-/]INCREMENTAL" "/INCREMENTAL:NO" CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO}")
    set(CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")
    string(REGEX REPLACE "[-/]INCREMENTAL" "/INCREMENTAL:NO" CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO}")
    set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /LTCG")

    set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /GL")
    set(CMAKE_STATIC_LINKER_FLAGS_MINSIZEREL "${CMAKE_STATIC_LINKER_FLAGS_MINSIZEREL} /LTCG")
    set(CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL "${CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL} /LTCG")
    set(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL} /LTCG")
  endif()
else()
  # Turn on Large-file Support
  add_definitions(-D_FILE_OFFSET_BITS=64)
  add_definitions(-D_LARGEFILE64_SOURCE)
  add_definitions(-D_LARGEFILE_SOURCE)
  # Turn compiler warnings up to 11
  add_cxx_compiler_flag(-Wall)
  add_cxx_compiler_flag(-Wextra)
  add_cxx_compiler_flag(-Wshadow)
  add_cxx_compiler_flag(-Wfloat-equal)
  add_cxx_compiler_flag(-Wold-style-cast)
  add_cxx_compiler_flag(-Wconversion)
  if(BENCHMARK_ENABLE_WERROR)
      add_cxx_compiler_flag(-Werror)
  endif()
  if (NOT BENCHMARK_ENABLE_TESTING)
    # Disable warning when compiling tests as gtest does not use 'override'.
    add_cxx_compiler_flag(-Wsuggest-override)
  endif()
  add_cxx_compiler_flag(-pedantic)
  add_cxx_compiler_flag(-pedantic-errors)
  add_cxx_compiler_flag(-Wshorten-64-to-32)
  add_cxx_compiler_flag(-fstrict-aliasing)
  # Disable warnings regarding deprecated parts of the library while building
  # and testing those parts of the library.
  add_cxx_compiler_flag(-Wno-deprecated-declarations)
  if (CMAKE_CXX_COMPILER_ID STREQUAL "Intel" OR CMAKE_CXX_COMPILER_ID STREQUAL "IntelLLVM")
    # Intel silently ignores '-Wno-deprecated-declarations',
    # warning no. 1786 must be explicitly disabled.
    # See #631 for rationale.
    add_cxx_compiler_flag(-wd1786)
    add_cxx_compiler_flag(-fno-finite-math-only)
  endif()
  # Disable deprecation warnings for release builds (when -Werror is enabled).
  if(BENCHMARK_ENABLE_WERROR)
      add_cxx_compiler_flag(-Wno-deprecated)
  endif()
  if (NOT BENCHMARK_ENABLE_EXCEPTIONS)
    add_cxx_compiler_flag(-fno-exceptions)
  endif()

  if (HAVE_CXX_FLAG_FSTRICT_ALIASING)
    if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Intel" AND NOT CMAKE_CXX_COMPILER_ID STREQUAL "IntelLLVM") #ICC17u2: Many false positives for Wstrict-aliasing
      add_cxx_compiler_flag(-Wstrict-aliasing)
    endif()
  endif()
  # ICC17u2: overloaded virtual function "benchmark::Fixture::SetUp" is only partially overridden
  # (because of deprecated overload)
  add_cxx_compiler_flag(-wd654)
  add_cxx_compiler_flag(-Wthread-safety)
  if (HAVE_CXX_FLAG_WTHREAD_SAFETY)
    cxx_feature_check(THREAD_SAFETY_ATTRIBUTES "-DINCLUDE_DIRECTORIES=${PROJECT_SOURCE_DIR}/include")
  endif()

  # On most UNIX like platforms g++ and clang++ define _GNU_SOURCE as a
  # predefined macro, which turns on all of the wonderful libc extensions.
  # However g++ doesn't do this in Cygwin so we have to define it ourselves
  # since we depend on GNU/POSIX/BSD extensions.
  if (CYGWIN)
    add_definitions(-D_GNU_SOURCE=1)
  endif()

  if (QNXNTO)
    add_definitions(-D_QNX_SOURCE)
  endif()

  # Link time optimisation
  if (BENCHMARK_ENABLE_LTO)
    add_cxx_compiler_flag(-flto)
    add_cxx_compiler_flag(-Wno-lto-type-mismatch)
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
      find_program(GCC_AR gcc-ar)
      if (GCC_AR)
        set(CMAKE_AR ${GCC_AR})
      endif()
      find_program(GCC_RANLIB gcc-ranlib)
      if (GCC_RANLIB)
        set(CMAKE_RANLIB ${GCC_RANLIB})
      endif()
    elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
      include(llvm-toolchain)
    endif()
  endif()

  # Coverage build type
  set(BENCHMARK_CXX_FLAGS_COVERAGE "${CMAKE_CXX_FLAGS_DEBUG}"
    CACHE STRING "Flags used by the C++ compiler during coverage builds."
    FORCE)
  set(BENCHMARK_EXE_LINKER_FLAGS_COVERAGE "${CMAKE_EXE_LINKER_FLAGS_DEBUG}"
    CACHE STRING "Flags used for linking binaries during coverage builds."
    FORCE)
  set(BENCHMARK_SHARED_LINKER_FLAGS_COVERAGE "${CMAKE_SHARED_LINKER_FLAGS_DEBUG}"
    CACHE STRING "Flags used by the shared libraries linker during coverage builds."
    FORCE)
  mark_as_advanced(
    BENCHMARK_CXX_FLAGS_COVERAGE
    BENCHMARK_EXE_LINKER_FLAGS_COVERAGE
    BENCHMARK_SHARED_LINKER_FLAGS_COVERAGE)
  set(CMAKE_BUILD_TYPE "${CMAKE_BUILD_TYPE}" CACHE STRING
    "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Coverage.")
  add_cxx_compiler_flag(--coverage COVERAGE)
endif()

if (BENCHMARK_USE_LIBCXX)
  if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
    add_cxx_compiler_flag(-stdlib=libc++)
  elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU" OR
          "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Intel" OR
          "${CMAKE_CXX_COMPILER_ID}" STREQUAL "IntelLLVM")
    add_cxx_compiler_flag(-nostdinc++)

=== third_party/c-ares/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 3.5.0...3.10.0)

INCLUDE (CheckIncludeFiles)
INCLUDE (CheckTypeSize)
INCLUDE (CheckFunctionExists)
INCLUDE (CheckSymbolExists)
INCLUDE (CheckCSourceCompiles)
INCLUDE (CheckStructHasMember)
INCLUDE (CheckLibraryExists)

PROJECT (c-ares LANGUAGES C VERSION "1.19.1" )

# Set this version before release
SET (CARES_VERSION "${PROJECT_VERSION}")

INCLUDE (GNUInstallDirs) # include this *AFTER* PROJECT(), otherwise paths are wrong.

# This is for libtool compatibility, and specified in a form that is easily
# translatable from libtool (even if the actual form doesn't make sense).
# For instance, in an autotools project, in Makefile.am there is a line that
# contains something like:
#     -version-info 4:0:2
# This breaks down into sections of current:revision:age
# This then generates a version of  "(current-age).age.revision"  with an
# interface version of "(current-age)"
# For example, a version of 4:0:2 would generate output such as:
#    libname.so   -> libname.so.2
#    libname.so.2 -> libname.so.2.2.0
SET (CARES_LIB_VERSIONINFO "8:1:6")


OPTION (CARES_STATIC     "Build as a static library"                                             OFF)
OPTION (CARES_SHARED     "Build as a shared library"                                             ON)
OPTION (CARES_INSTALL    "Create installation targets (chain builders may want to disable this)" ON)
OPTION (CARES_STATIC_PIC "Build the static library as PIC (position independent)"                OFF)
OPTION (CARES_BUILD_TESTS "Build and run tests"                                                  OFF)
OPTION (CARES_BUILD_CONTAINER_TESTS "Build and run container tests (implies CARES_BUILD_TESTS, Linux only)" OFF)
OPTION (CARES_BUILD_TOOLS "Build tools"                                                          ON)
SET    (CARES_RANDOM_FILE "/dev/urandom" CACHE STRING "Suitable File / Device Path for entropy, such as /dev/urandom")


# Tests require static to be enabled on Windows to be able to access otherwise hidden symbols
IF (CARES_BUILD_TESTS AND (NOT CARES_STATIC) AND WIN32)
	SET (CARES_STATIC ON)
	SET (CARES_STATIC_PIC ON)
	MESSAGE (WARNING "Static building was requested be disabled, but reenabled to support tests")
ENDIF ()

# allow linking against the static runtime library in msvc
IF (MSVC)
	OPTION (CARES_MSVC_STATIC_RUNTIME "Link against the static runtime library" OFF)
	IF (CARES_MSVC_STATIC_RUNTIME)
		# CMAKE_CONFIGURATION_TYPES is empty on non-IDE generators (Ninja, NMake)
		# and that's why we also use CMAKE_BUILD_TYPE to cover for those generators.
		# For IDE generators, CMAKE_BUILD_TYPE is usually empty
		FOREACH (config_type ${CMAKE_CONFIGURATION_TYPES} ${CMAKE_BUILD_TYPE})
			STRING (TOUPPER ${config_type} upper_config_type)
			SET (flag_var "CMAKE_C_FLAGS_${upper_config_type}")
			IF (${flag_var} MATCHES "/MD")
				STRING (REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
			ENDIF ()
		ENDFOREACH ()

		# clean up
		SET (upper_config_type)
		SET (config_type)
		SET (flag_var)
	ENDIF ()
ENDIF ()

# Keep build organized.
SET (CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}")
SET (CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
SET (CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}")
SET (PACKAGE_DIRECTORY ${PROJECT_BINARY_DIR}/package)

# Destinations for installing different kinds of targets (pass to install command).
SET (TARGETS_INST_DEST
	RUNTIME DESTINATION  ${CMAKE_INSTALL_BINDIR}
	BUNDLE DESTINATION   ${CMAKE_INSTALL_BINDIR}
	LIBRARY DESTINATION  ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION  ${CMAKE_INSTALL_LIBDIR}
)

# Function in Library
# CHECK_LIBRARY_EXISTS can't be used as it will return true if the function
# is found in a different required/dependent library.
MACRO (CARES_FUNCTION_IN_LIBRARY func lib var)

	SET (_ORIG_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
	SET (CMAKE_REQUIRED_LIBRARIES )
	CHECK_FUNCTION_EXISTS ("${func}" "_CARES_FUNC_IN_LIB_GLOBAL_${func}")
	SET (CMAKE_REQUIRED_LIBRARIES "${_ORIG_CMAKE_REQUIRED_LIBRARIES}")

	IF ("${_CARES_FUNC_IN_LIB_GLOBAL_${func}}")
		SET (${var} FALSE)
	ELSE ()
		CHECK_LIBRARY_EXISTS ("${lib}" "${func}" "" ${var})
	ENDIF ()
ENDMACRO ()

# Look for dependent/required libraries
CARES_FUNCTION_IN_LIBRARY (res_servicename resolv HAVE_RES_SERVICENAME_IN_LIBRESOLV)
IF (HAVE_RES_SERVICENAME_IN_LIBRESOLV)
	SET (HAVE_LIBRESOLV 1)
ENDIF ()

IF (APPLE)
	CHECK_C_SOURCE_COMPILES ("
	#include <stdio.h>
	#include <TargetConditionals.h>
	int main() {
#if TARGET_OS_IPHONE == 0
#error Not an iPhone target
#endif
return 0;
	}
	"
	IOS)

	CHECK_C_SOURCE_COMPILES ("
#include <stdio.h>
#include <TargetConditionals.h>
	int main() {
#if TARGET_OS_IPHONE == 0 || __IPHONE_OS_VERSION_MIN_REQUIRED < 100000
#  error Not iOS v10
#endif
return 0;
	}
	"
	IOS_V10)

	CHECK_C_SOURCE_COMPILES ("
#include <stdio.h>
#include <AvailabilityMacros.h>
#ifndef MAC_OS_X_VERSION_10_12
#  define MAC_OS_X_VERSION_10_12 101200
#endif
	int main() {
#if MAC_OS_X_VERSION_MIN_REQUIRED < MAC_OS_X_VERSION_10_12
#  error Not MacOSX 10.12 or higher
#endif
return 0;
	}
	"
	MACOS_V1012)
ENDIF ()

IF ((IOS OR APPLE OR ZOS) AND HAVE_LIBRESOLV)
	SET (CARES_USE_LIBRESOLV 1)
ENDIF()


CARES_FUNCTION_IN_LIBRARY (gethostbyname nsl HAVE_LIBNSL)
CARES_FUNCTION_IN_LIBRARY (gethostbyname socket HAVE_GHBN_LIBSOCKET)
CARES_FUNCTION_IN_LIBRARY (gethostbyname network HAVE_LIBNETWORK)
CARES_FUNCTION_IN_LIBRARY (socket socket HAVE_SOCKET_LIBSOCKET)
IF (HAVE_GHBN_LIBSOCKET OR HAVE_SOCKET_LIBSOCKET)
	SET(HAVE_LIBSOCKET TRUE)
ENDIF ()
CARES_FUNCTION_IN_LIBRARY (socket network HAVE_LIBNETWORK)
CARES_FUNCTION_IN_LIBRARY (clock_gettime rt HAVE_LIBRT)


# Look for necessary includes
CHECK_INCLUDE_FILES (sys/types.h           HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES (sys/socket.h          HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILES (sys/sockio.h          HAVE_SYS_SOCKIO_H)
CHECK_INCLUDE_FILES (arpa/inet.h           HAVE_ARPA_INET_H)
CHECK_INCLUDE_FILES (arpa/nameser_compat.h HAVE_ARPA_NAMESER_COMPAT_H)
CHECK_INCLUDE_FILES (arpa/nameser.h        HAVE_ARPA_NAMESER_H)
CHECK_INCLUDE_FILES (assert.h              HAVE_ASSERT_H)
CHECK_INCLUDE_FILES (errno.h               HAVE_ERRNO_H)
CHECK_INCLUDE_FILES (fcntl.h               HAVE_FCNTL_H)
CHECK_INCLUDE_FILES (inttypes.h            HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES (limits.h              HAVE_LIMITS_H)
CHECK_INCLUDE_FILES (malloc.h              HAVE_MALLOC_H)
CHECK_INCLUDE_FILES (memory.h              HAVE_MEMORY_H)
CHECK_INCLUDE_FILES (netdb.h               HAVE_NETDB_H)
CHECK_INCLUDE_FILES (netinet/in.h          HAVE_NETINET_IN_H)
CHECK_INCLUDE_FILES (net/if.h              HAVE_NET_IF_H)
CHECK_INCLUDE_FILES (signal.h              HAVE_SIGNAL_H)
CHECK_INCLUDE_FILES (socket.h              HAVE_SOCKET_H)
CHECK_INCLUDE_FILES (stdbool.h             HAVE_STDBOOL_H)
CHECK_INCLUDE_FILES (stdint.h              HAVE_STDINT_H)
CHECK_INCLUDE_FILES (stdlib.h              HAVE_STDLIB_H)
CHECK_INCLUDE_FILES (strings.h             HAVE_STRINGS_H)
CHECK_INCLUDE_FILES (string.h              HAVE_STRING_H)
CHECK_INCLUDE_FILES (stropts.h             HAVE_STROPTS_H)
CHECK_INCLUDE_FILES (sys/ioctl.h           HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILES (sys/param.h           HAVE_SYS_PARAM_H)
CHECK_INCLUDE_FILES (sys/select.h          HAVE_SYS_SELECT_H)
CHECK_INCLUDE_FILES (sys/stat.h            HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES (sys/time.h            HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES (sys/uio.h             HAVE_SYS_UIO_H)
CHECK_INCLUDE_FILES (time.h                HAVE_TIME_H)
CHECK_INCLUDE_FILES (dlfcn.h               HAVE_DLFCN_H)
CHECK_INCLUDE_FILES (unistd.h              HAVE_UNISTD_H)

# On OpenBSD, you must include sys/types.h before netinet/tcp.h
IF (HAVE_SYS_TYPES_H)
  CHECK_INCLUDE_FILES ("sys/types.h;netinet/tcp.h"         HAVE_NETINET_TCP_H)
ELSE ()
  CHECK_INCLUDE_FILES (netinet/tcp.h                       HAVE_NETINET_TCP_H)
ENDIF ()

# Include order matters for these windows files.
# As cygwin environment has both socket.h and winsock2.h
# headers check WIN32 not to include the later one here
IF (WIN32)
CHECK_INCLUDE_FILES ("winsock2.h;windows.h"            HAVE_WINSOCK2_H)
CHECK_INCLUDE_FILES ("winsock2.h;ws2tcpip.h;windows.h" HAVE_WS2TCPIP_H)
CHECK_INCLUDE_FILES ("winsock.h;windows.h"             HAVE_WINSOCK_H)
CHECK_INCLUDE_FILES (windows.h                         HAVE_WINDOWS_H)
ENDIF ()

# Set system-specific compiler flags
IF (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
	LIST (APPEND SYSFLAGS -D_DARWIN_C_SOURCE)
ELSEIF (CMAKE_SYSTEM_NAME STREQUAL "Linux")
	LIST (APPEND SYSFLAGS -D_GNU_SOURCE -D_POSIX_C_SOURCE=199309L -D_XOPEN_SOURCE=600)
ELSEIF (CMAKE_SYSTEM_NAME STREQUAL "SunOS")
	LIST (APPEND SYSFLAGS -D__EXTENSIONS__ -D_REENTRANT -D_XOPEN_SOURCE=600)
ELSEIF (CMAKE_SYSTEM_NAME STREQUAL "AIX")
	LIST (APPEND SYSFLAGS -D_ALL_SOURCE -D_XOPEN_SOURCE=600 -D_USE_IRS)
ELSEIF (CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
	# Don't define _XOPEN_SOURCE on FreeBSD, it actually reduces visibility instead of increasing it
ELSEIF (WIN32)
	LIST (APPEND SYSFLAGS -DWIN32_LEAN_AND_MEAN -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE)
ENDIF ()
ADD_DEFINITIONS(${SYSFLAGS})



# Tell C-Ares about libraries to depend on
IF (HAVE_LIBRESOLV)
	LIST (APPEND CARES_DEPENDENT_LIBS resolv)
ENDIF ()
IF (HAVE_LIBNSL)
	LIST (APPEND CARES_DEPENDENT_LIBS nsl)
ENDIF ()
IF (HAVE_LIBSOCKET)
	LIST (APPEND CARES_DEPENDENT_LIBS socket)
ENDIF ()
IF (HAVE_LIBNETWORK)
	LIST (APPEND CARES_DEPENDENT_LIBS network)
ENDIF ()
IF (HAVE_LIBRT)
	LIST (APPEND CARES_DEPENDENT_LIBS rt)
ENDIF ()
IF (WIN32)
	LIST (APPEND CARES_DEPENDENT_LIBS ws2_32 advapi32 iphlpapi)
ENDIF ()


# When checking for symbols, we need to make sure we set the proper
# headers, libraries, and definitions for the detection to work properly
# CMAKE_REQUIRED_DEFINITIONS, CMAKE_REQUIRED_LIBRARIES, and
# CMAKE_EXTRA_INCLUDE_FILES.  When we're done with the detection, we'll
# unset them.

SET (CMAKE_REQUIRED_DEFINITIONS ${SYSFLAGS})
LIST (APPEND CMAKE_REQUIRED_LIBRARIES ${CARES_DEPENDENT_LIBS})

MACRO (CARES_EXTRAINCLUDE_IFSET var include)
	IF (${var})
		LIST (APPEND CMAKE_EXTRA_INCLUDE_FILES ${include})
	ENDIF ()
ENDMACRO ()

CARES_EXTRAINCLUDE_IFSET (HAVE_STDBOOL_H      stdbool.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_SYS_TYPES_H    sys/types.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_ARPA_INET_H    arpa/inet.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_ARPA_NAMESER_H arpa/nameser.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_NETDB_H        netdb.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_NET_IF_H       net/if.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_NETINET_IN_H   netinet/in.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_NETINET_TCP_H  netinet/tcp.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_SIGNAL_H       signal.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_STDLIB_H       stdlib.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_STRING_H       string.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_STRINGS_H      strings.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_SYS_IOCTL_H    sys/ioctl.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_SYS_SELECT_H   sys/select.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_SYS_SOCKET_H   sys/socket.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_SYS_SOCKIO_H	sys/sockio.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_SYS_TIME_H     sys/time.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_SYS_UIO_H      sys/uio.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_TIME_H         time.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_FCNTL_H        fcntl.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_UNISTD_H       unistd.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_WINSOCK2_H     winsock2.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_WS2TCPIP_H     ws2tcpip.h)
CARES_EXTRAINCLUDE_IFSET (HAVE_WINDOWS_H      windows.h)

# Check Types
# CHECK_TYPE_SIZE can't be used to see if a type exists because on Apple when
# building multi-arch, it will throw an error.  So we need to wrap
# CHECK_C_SOURCE_COMPILES for our tests.
MACRO (CARES_TYPE_EXISTS type var)
	SET(_CARES_C_SOURCE "
		#include <stdio.h>
		#include <stdlib.h>
	")
	FOREACH(_C_HEADER ${CMAKE_EXTRA_INCLUDE_FILES})

=== third_party/gperftools/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

# Please note that cmake support is very preliminary. Autotools-based
# build is the only fully supported build for now.

# Based on configure.ac

project(gperftools VERSION 2.15 LANGUAGES C CXX
        DESCRIPTION "Performance tools for C++"
        HOMEPAGE_URL https://github.com/gperftools/gperftools)

if (NOT WIN32)
  add_compile_options(-fvisibility=default)
endif()

# Update this value for every release!
set(TCMALLOC_SO_VERSION 9.16.5)
set(PROFILER_SO_VERSION 5.11.5)
set(TCMALLOC_AND_PROFILER_SO_VERSION 10.11.6)

# The user can choose not to compile in the heap-profiler, the
# heap-checker, or the cpu-profiler.  There's also the possibility
# for a 'fully minimal' compile, which leaves out the stacktrace
# code as well.  By default, we include all of these that the
# target system supports.
set(DEFAULT_BUILD_CPU_PROFILER ON)
set(DEFAULT_BUILD_HEAP_PROFILER ON)
set(DEFAULT_BUILD_HEAP_CHECKER OFF)
set(DEFAULT_BUILD_DEBUGALLOC ON)
set(DEFAULT_BUILD_MINIMAL OFF)

set(DEFAULT_TCMALLOC_ALIGNMENT 16)
set(NEED_NANOSLEEP ON) # Used later, to decide if to run ACX_NANOSLEEP

set(HOST string(TOLOWER "${CMAKE_SYSTEM_NAME}"))

if(MINGW OR MSVC)
  set(DEFAULT_BUILD_MINIMAL ON)
  set(DEFAULT_BUILD_DEBUGALLOC OFF)
  set(NEED_NANOSLEEP OFF)
elseif(CYGWIN)
  set(DEFAULT_BUILD_CPU_PROFILER OFF)
endif()

# Heap checker is Linux-only (and deprecated).
if(CMAKE_SYSTEM MATCHES Linux)
  set(DEFAULT_BUILD_HEAP_CHECKER ON)
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckTypeSize)
include(CheckVariableExists)
include(CMakeDependentOption)
include(CTest)
include(CPack)
include(GNUInstallDirs)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(DefineTargetVariables)

define_target_variables()

# Currently only backtrace works on s390.
if(s390 OR OSX)
  set(default_enable_libunwind OFF)
  set(default_enable_backtrace ON)
else()
  set(default_enable_libunwind ON)
  set(default_enable_backtrace OFF)
endif()

# Disable libunwind linking on ppc64 by default.
if(PPC64)
  set(default_enable_libunwind OFF)
  set(default_tcmalloc_pagesize 64)
else()
  if(PPC)
    set(default_enable_libunwind OFF)
  else()
    set(default_enable_libunwind ON)
  endif()
  set(default_tcmalloc_pagesize 8)
endif()

cmake_dependent_option(
  GPERFTOOLS_BUILD_CPU_PROFILER "Build cpu-profiler" ${DEFAULT_BUILD_CPU_PROFILER}
  "NOT gperftools_build_minimal" OFF)
cmake_dependent_option(
  GPERFTOOLS_BUILD_HEAP_PROFILER "Build heap-profiler" ${DEFAULT_BUILD_HEAP_PROFILER}
  "NOT gperftools_build_minimal" OFF)
cmake_dependent_option(
  GPERFTOOLS_BUILD_HEAP_CHECKER "Build heap-checker" ${DEFAULT_BUILD_HEAP_CHECKER}
  "NOT gperftools_build_minimal" OFF)
cmake_dependent_option(
  GPERFTOOLS_BUILD_DEBUGALLOC "Build debugalloc" ${DEFAULT_BUILD_DEBUGALLOC}
  "NOT gperftools_build_minimal" OFF)
option(
        gperftools_build_minimal
        "Build only tcmalloc-minimal (and maybe tcmalloc-minimal-debug)"
        ${DEFAULT_BUILD_MINIMAL})
if(gperftools_build_minimal)
  set(GPERFTOOLS_BUILD_CPU_PROFILER OFF)
  set(GPERFTOOLS_BUILD_HEAP_PROFILER OFF)
  set(GPERFTOOLS_BUILD_HEAP_CHECKER OFF)
endif()

cmake_dependent_option(
  gperftools_build_benchmark "Build benchmark" ON "NOT MINGW AND NOT MSVC" OFF)

option(gperftools_enable_stacktrace_via_backtrace
       "Enable use of backtrace() for stacktrace capturing (may deadlock)"
       ${default_enable_backtrace})
option(gperftools_enable_libunwind
       "Enable libunwind linking"
       ${default_enable_libunwind})

set(enable_backtrace ${gperftools_enable_stacktrace_via_backtrace})
set(enable_libunwind ${gperftools_enable_libunwind})

option(gperftools_enable_libgcc_unwinder_by_default
       "Prefer libgcc's _Unwind_Backtrace as default stacktrace capturing method"
       OFF)
set(PREFER_LIBGCC_UNWINDER ${gperftools_enable_libgcc_unwinder_by_default})

set(gperftools_tcmalloc_pagesize ${default_tcmalloc_pagesize}
  CACHE STRING "Set the tcmalloc internal page size")
set(allowed_page_sizes LIST "4;8;16;32;64;128;256")
set_property(CACHE gperftools_tcmalloc_pagesize PROPERTY STRINGS ${allowed_page_sizes})
if(NOT gperftools_tcmalloc_pagesize IN_LIST allowed_page_sizes)
  message(WARNING
    "Invalid gperftools_tcmalloc_pagesize (${gperftools_tcmalloc_pagesize}), "
    "setting to default value (${default_tcmalloc_pagesize})")
  set(gperftools_tcmalloc_pagesize ${default_tcmalloc_pagesize})
endif()
if (gperftools_tcmalloc_pagesize EQUAL 4)
  set(TCMALLOC_PAGE_SIZE_SHIFT 12)
elseif(gperftools_tcmalloc_pagesize EQUAL 8)
  # default page size
elseif(gperftools_tcmalloc_pagesize EQUAL 16)
  set(TCMALLOC_PAGE_SIZE_SHIFT 14)
elseif(gperftools_tcmalloc_pagesize EQUAL 32)
  set(TCMALLOC_PAGE_SIZE_SHIFT 15)
elseif(gperftools_tcmalloc_pagesize EQUAL 64)
  set(TCMALLOC_PAGE_SIZE_SHIFT 16)
elseif(gperftools_tcmalloc_pagesize EQUAL 128)
  set(TCMALLOC_PAGE_SIZE_SHIFT 17)
elseif(gperftools_tcmalloc_pagesize EQUAL 256)
  set(TCMALLOC_PAGE_SIZE_SHIFT 18)
else()
  message(WARNING
  "${gperftools_tcmalloc_pagesize}K size not supported, using default tcmalloc page size.")
endif()

set(gperftools_tcmalloc_alignment ${DEFAULT_TCMALLOC_ALIGNMENT}
  CACHE STRING "Set the tcmalloc allocation alignment")
set_property(CACHE gperftools_tcmalloc_alignment PROPERTY STRINGS "8" "16")
if(NOT gperftools_tcmalloc_alignment STREQUAL "8" AND
   NOT gperftools_tcmalloc_alignment STREQUAL "16")
  message(WARNING
      "Invalid gperftools_tcmalloc_alignment (${gperftools_tcmalloc_alignment}), "
      "setting to default value (${DEFAULT_TCMALLOC_ALIGNMENT})")
  set(gperftools_tcmalloc_alignment ${DEFAULT_TCMALLOC_ALIGNMENT})
endif()
if(gperftools_tcmalloc_alignment STREQUAL "8")
  set(TCMALLOC_ALIGN_8BYTES ON)
endif()

# AX_CXX_COMPILE_STDCXX(11, ext, mandatory)
if(cxx_std_17 IN_LIST CMAKE_CXX_COMPILE_FEATURES)
  set(CMAKE_CXX_STANDARD 17) # std::align_val_t
else()
  set(CMAKE_CXX_STANDARD 11)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS ON)

# AX_C___ATTRIBUTE__
check_c_source_compiles("#include <stdlib.h>
                         static void foo(void) __attribute__ ((unused));
                         void foo(void) { exit(1); }
                         int main() { return 0; }"
        HAVE___ATTRIBUTE__)

check_c_source_compiles("#include <stdlib.h>
                        void foo(void) __attribute__((aligned(128)));
                        void foo(void) { exit(1); }
                        int main() { return 0; }"
        HAVE___ATTRIBUTE__ALIGNED_FN)

set(CMAKE_EXTRA_INCLUDE_FILES "malloc.h")
check_type_size("struct mallinfo" STRUCT_MALLINFO LANGUAGE CXX)
check_type_size("struct mallinfo2" STRUCT_MALLINFO2 LANGUAGE CXX)
set(CMAKE_EXTRA_INCLUDE_FILES "elf.h")
check_type_size("Elf32_Versym" ELF32_VERSYM LANGUAGE CXX) # for vdso_support.h
set(CMAKE_EXTRA_INCLUDE_FILES)
check_function_exists("sbrk" HAVE_SBRK) # for tcmalloc to get memory
check_function_exists("__sbrk" HAVE___SBRK) # for tcmalloc to get memory
check_function_exists("geteuid" HAVE_GETEUID) # for turning off services when run as root
check_function_exists("fork" HAVE_FORK) # for the pthread_atfork setup
check_include_file("features.h" HAVE_FEATURES_H) # for vdso_support.h, Where __GLIBC__ is defined
check_include_file("malloc.h" HAVE_MALLOC_H) # some systems define stuff there, others not
check_include_file("glob.h" HAVE_GLOB_H) # for heap-profile-table (cleaning up profiles)
check_include_file("execinfo.h" HAVE_EXECINFO_H) # for stacktrace? and heapchecker_unittest
check_include_file("unwind.h" HAVE_UNWIND_H) # for stacktrace
check_include_file("sched.h" HAVE_SCHED_H) # for being nice in our spinlock code
check_include_file("sys/syscall.h" HAVE_SYS_SYSCALL_H)
check_include_file("sys/socket.h" HAVE_SYS_SOCKET_H) # optional; for forking out to symbolizer
check_include_file("sys/wait.h" HAVE_SYS_WAIT_H) # optional; for forking out to symbolizer
check_include_file("poll.h" HAVE_POLL_H) # optional; for forking out to symbolizer
check_include_file("fcntl.h" HAVE_FCNTL_H) # for tcmalloc_unittest
check_include_file("grp.h" HAVE_GRP_H) # for heapchecker_unittest
check_include_file("pwd.h" HAVE_PWD_H) # for heapchecker_unittest
check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H) # for memalign_unittest.cc
check_include_file("sys/cdefs.h" HAVE_SYS_CDEFS_H) # Where glibc defines __THROW

check_include_file("sys/ucontext.h" HAVE_SYS_UCONTEXT_H)
check_include_file("ucontext.h" HAVE_UCONTEXT_H)
check_include_file("cygwin/signal.h" HAVE_CYGWIN_SIGNAL_H) # ucontext on cywgin
check_include_file("asm/ptrace.h" HAVE_ASM_PTRACE_H) # get ptrace macros, e.g. PT_NIP

check_include_file("unistd.h" HAVE_UNISTD_H)
# We also need <ucontext.h>/<sys/ucontext.h>, but we get those from
# AC_PC_FROM_UCONTEXT, below.

# We override a lot of memory allocation routines, not all of which are
# standard.  For those the system doesn't declare, we'll declare ourselves.
set(CMAKE_REQUIRED_DEFINITIONS -D_XOPEN_SOURCE=600)
check_symbol_exists("cfree" "stdlib.h;malloc.h" HAVE_DECL_CFREE)
check_symbol_exists("posix_memalign" "stdlib.h;malloc.h" HAVE_DECL_POSIX_MEMALIGN)
check_symbol_exists("memalign" "stdlib.h;malloc.h" HAVE_DECL_MEMALIGN)
check_symbol_exists("valloc" "stdlib.h;malloc.h" HAVE_DECL_VALLOC)
check_symbol_exists("pvalloc" "stdlib.h;malloc.h" HAVE_DECL_PVALLOC)
set(CMAKE_REQUIRED_DEFINITIONS)

if(HAVE_STRUCT_MALLINFO)
    set(HAVE_STRUCT_MALLINFO 1)
else()
    set(HAVE_STRUCT_MALLINFO 0)
endif()

if(HAVE_STRUCT_MALLINFO2)
    set(HAVE_STRUCT_MALLINFO2 1)
else()
    set(HAVE_STRUCT_MALLINFO2 0)
endif()

# We hardcode HAVE_MMAP to 1. There are no interesting systems anymore
# without functional mmap. And our windows (except mingw) builds
# aren't using autoconf. So we keep HAVE_MMAP define, but only to
# distingush windows and rest.
if(NOT WIN32)
  set(HAVE_MMAP 1)
endif()

# Some tests test the behavior of .so files, and only make sense for dynamic.
option(GPERFTOOLS_BUILD_STATIC "Enable Static" ON)

option(GPERFTOOLS_ENABLE_INSTALL "Enable Install" OFF)
option(GPERFTOOLS_BUILD_TESTING "Enable Testing" OFF)

if(gperftools_enable_libunwind)
  check_include_file("libunwind.h" HAVE_LIBUNWIND_H)
  if(HAVE_LIBUNWIND_H)
    find_library(libunwind_location NAMES unwind)
    if(libunwind_location)
      check_library_exists(
        unwind backtrace ${libunwind_location} have_libunwind)
    endif()
    if(have_libunwind)
      set(unwind_libs ${libunwind_location})
      set(will_use_libunwind ON)
      set(USE_LIBUNWIND 1)
    endif()
  endif()
endif()

# See if the compiler supports -Wno-unused-result.
# Newer ubuntu's turn on -D_FORTIFY_SOURCE=2, enabling
# __attribute__((warn_unused_result)) for things like write(),
# which we don't care about.
check_c_compiler_flag("-Wno-unused-result" have_w_no_unused_result)

check_c_compiler_flag("-fno-omit-frame-pointer -momit-leaf-frame-pointer" have_omit_leaf_fp)
check_c_source_compiles("
  #if !(__i386__ || __x86_64__ || __riscv || __aarch64__)
  #error unsupported arch
  #endif
  int main() { return 0; }
  "
  use_omit_leaf_fp)

if (use_omit_leaf_fp AND NOT MSVC)
  add_compile_options(-fno-omit-frame-pointer -momit-leaf-frame-pointer)
endif()

option(gperftools_dynamic_sized_delete_support
       "Try to build run-time switch for sized delete operator"
       OFF)
if(gperftools_dynamic_sized_delete_support)
  set(ENABLE_DYNAMIC_SIZED_DELETE 1)
endif()

option(gperftools_sized_delete "Build sized delete operator" OFF)
if(gperftools_sized_delete)
  set(ENABLE_SIZED_DELETE 1)
endif()

if(NOT MSVC)
  set(CMAKE_REQUIRED_FLAGS -fsized-deallocation)
  check_cxx_source_compiles("
  #include <new>
  int main() { (::operator delete)(0, 256); return 0; }"
          have_sized_deallocation)
  set(CMAKE_REQUIRED_FLAGS)
endif()

check_cxx_source_compiles("
  #include <new>

=== third_party/leveldb/CMakeLists.txt ===
# Copyright 2017 The LevelDB Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file. See the AUTHORS file for names of contributors.

cmake_minimum_required(VERSION 3.9)
# Keep the version below in sync with the one in db.h
project(leveldb VERSION 1.23.0 LANGUAGES C CXX)

# C standard can be overridden when this is used as a sub-project.
if(NOT CMAKE_C_STANDARD)
  # This project can use C11, but will gracefully decay down to C89.
  set(CMAKE_C_STANDARD 11)
  set(CMAKE_C_STANDARD_REQUIRED OFF)
  set(CMAKE_C_EXTENSIONS OFF)
endif(NOT CMAKE_C_STANDARD)

# C++ standard can be overridden when this is used as a sub-project.
if(NOT CMAKE_CXX_STANDARD)
  # This project requires C++11.
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif(NOT CMAKE_CXX_STANDARD)

if (WIN32)
  set(LEVELDB_PLATFORM_NAME LEVELDB_PLATFORM_WINDOWS)
  # TODO(cmumford): Make UNICODE configurable for Windows.
  add_definitions(-D_UNICODE -DUNICODE)
else (WIN32)
  set(LEVELDB_PLATFORM_NAME LEVELDB_PLATFORM_POSIX)
endif (WIN32)

option(LEVELDB_BUILD_UTILS "Build LevelDB's utils" ON)
option(LEVELDB_BUILD_TESTS "Build LevelDB's unit tests" ON)
option(LEVELDB_BUILD_BENCHMARKS "Build LevelDB's benchmarks" ON)
option(LEVELDB_INSTALL "Install LevelDB's header and library" ON)

include(CheckIncludeFile)
check_include_file("unistd.h" HAVE_UNISTD_H)

include(CheckLibraryExists)
check_library_exists(crc32c crc32c_value "" HAVE_CRC32C)
check_library_exists(snappy snappy_compress "" HAVE_SNAPPY)
check_library_exists(zstd zstd_compress "" HAVE_ZSTD)
check_library_exists(tcmalloc malloc "" HAVE_TCMALLOC)

include(CheckCXXSymbolExists)
# Using check_cxx_symbol_exists() instead of check_c_symbol_exists() because
# we're including the header from C++, and feature detection should use the same
# compiler language that the project will use later. Principles aside, some
# versions of do not expose fdatasync() in <unistd.h> in standard C mode
# (-std=c11), but do expose the function in standard C++ mode (-std=c++11).
check_cxx_symbol_exists(fdatasync "unistd.h" HAVE_FDATASYNC)
check_cxx_symbol_exists(F_FULLFSYNC "fcntl.h" HAVE_FULLFSYNC)
check_cxx_symbol_exists(O_CLOEXEC "fcntl.h" HAVE_O_CLOEXEC)

if(NOT MSVC)
  # Enable strict prototype warnings for C code in clang and gcc.
  if(NOT CMAKE_C_FLAGS MATCHES "-Wstrict-prototypes")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wstrict-prototypes")
  endif(NOT CMAKE_C_FLAGS MATCHES "-Wstrict-prototypes")

  # Disable C++ exceptions.
  string(REGEX REPLACE "-fexceptions" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions")

  # Disable RTTI.
  string(REGEX REPLACE "-frtti" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-rtti")
endif(NOT MSVC)

# Test whether -Wthread-safety is available. See
# https://clang.llvm.org/docs/ThreadSafetyAnalysis.html
include(CheckCXXCompilerFlag)
check_cxx_compiler_flag(-Wthread-safety HAVE_CLANG_THREAD_SAFETY)

# Used by googletest.
check_cxx_compiler_flag(-Wno-missing-field-initializers
                        LEVELDB_HAVE_NO_MISSING_FIELD_INITIALIZERS)

include(CheckCXXSourceCompiles)

# Test whether C++17 __has_include is available.
check_cxx_source_compiles("
#if defined(__has_include) &&  __has_include(<string>)
#include <string>
#endif
int main() { std::string str; return 0; }
" HAVE_CXX17_HAS_INCLUDE)

set(LEVELDB_PUBLIC_INCLUDE_DIR "include/leveldb")
set(LEVELDB_PORT_CONFIG_DIR "include/port")

configure_file(
  "port/port_config.h.in"
  "${PROJECT_BINARY_DIR}/${LEVELDB_PORT_CONFIG_DIR}/port_config.h"
)

include_directories(
  "${PROJECT_BINARY_DIR}/include"
  "."
)

if(BUILD_SHARED_LIBS)
  # Only export LEVELDB_EXPORT symbols from the shared library.
  add_compile_options(-fvisibility=hidden)
endif(BUILD_SHARED_LIBS)

if(LEVELDB_INSTALL)
  # Must be included before CMAKE_INSTALL_INCLUDEDIR is used.
  include(GNUInstallDirs)
endif()

add_library(leveldb "")
target_sources(leveldb
  PRIVATE
    "${PROJECT_BINARY_DIR}/${LEVELDB_PORT_CONFIG_DIR}/port_config.h"
    "db/builder.cc"
    "db/builder.h"
    "db/c.cc"
    "db/db_impl.cc"
    "db/db_impl.h"
    "db/db_iter.cc"
    "db/db_iter.h"
    "db/dbformat.cc"
    "db/dbformat.h"
    "db/dumpfile.cc"
    "db/filename.cc"
    "db/filename.h"
    "db/log_format.h"
    "db/log_reader.cc"
    "db/log_reader.h"
    "db/log_writer.cc"
    "db/log_writer.h"
    "db/memtable.cc"
    "db/memtable.h"
    "db/repair.cc"
    "db/skiplist.h"
    "db/snapshot.h"
    "db/table_cache.cc"
    "db/table_cache.h"
    "db/version_edit.cc"
    "db/version_edit.h"
    "db/version_set.cc"
    "db/version_set.h"
    "db/write_batch_internal.h"
    "db/write_batch.cc"
    "port/port_stdcxx.h"
    "port/port.h"
    "port/thread_annotations.h"
    "table/block_builder.cc"
    "table/block_builder.h"
    "table/block.cc"
    "table/block.h"
    "table/filter_block.cc"
    "table/filter_block.h"
    "table/format.cc"
    "table/format.h"
    "table/iterator_wrapper.h"
    "table/iterator.cc"
    "table/merger.cc"
    "table/merger.h"
    "table/table_builder.cc"
    "table/table.cc"
    "table/two_level_iterator.cc"
    "table/two_level_iterator.h"
    "util/arena.cc"
    "util/arena.h"
    "util/bloom.cc"
    "util/cache.cc"
    "util/coding.cc"
    "util/coding.h"
    "util/comparator.cc"
    "util/crc32c.cc"
    "util/crc32c.h"
    "util/env.cc"
    "util/filter_policy.cc"
    "util/hash.cc"
    "util/hash.h"
    "util/logging.cc"
    "util/logging.h"
    "util/mutexlock.h"
    "util/no_destructor.h"
    "util/options.cc"
    "util/random.h"
    "util/status.cc"

  # Only CMake 3.3+ supports PUBLIC sources in targets exported by "install".
  $<$<VERSION_GREATER:CMAKE_VERSION,3.2>:PUBLIC>
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/c.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/cache.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/comparator.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/db.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/dumpfile.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/env.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/export.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/filter_policy.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/iterator.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/options.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/slice.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/status.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/table_builder.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/table.h"
    "${LEVELDB_PUBLIC_INCLUDE_DIR}/write_batch.h"
)

if (WIN32)
  target_sources(leveldb
    PRIVATE
      "util/env_windows.cc"
      "util/windows_logger.h"
  )
else (WIN32)
  target_sources(leveldb
    PRIVATE
      "util/env_posix.cc"
      "util/posix_logger.h"
  )
endif (WIN32)

# MemEnv is not part of the interface and could be pulled to a separate library.
target_sources(leveldb
  PRIVATE
    "helpers/memenv/memenv.cc"
    "helpers/memenv/memenv.h"
)

target_include_directories(leveldb
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

set_target_properties(leveldb
  PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})

target_compile_definitions(leveldb
  PRIVATE
    # Used by include/export.h when building shared libraries.
    LEVELDB_COMPILE_LIBRARY
    # Used by port/port.h.
    ${LEVELDB_PLATFORM_NAME}=1
)
if (NOT HAVE_CXX17_HAS_INCLUDE)
  target_compile_definitions(leveldb
    PRIVATE
      LEVELDB_HAS_PORT_CONFIG_H=1
  )
endif(NOT HAVE_CXX17_HAS_INCLUDE)

if(BUILD_SHARED_LIBS)
  target_compile_definitions(leveldb
    PUBLIC
      # Used by include/export.h.
      LEVELDB_SHARED_LIBRARY
  )
endif(BUILD_SHARED_LIBS)

if(HAVE_CLANG_THREAD_SAFETY)
  target_compile_options(leveldb
    PRIVATE
      -Werror=thread-safety)
endif(HAVE_CLANG_THREAD_SAFETY)

if(HAVE_CRC32C)
  target_link_libraries(leveldb PUBLIC crc32c)
endif(HAVE_CRC32C)
if(HAVE_SNAPPY)
  target_link_libraries(leveldb PUBLIC snappy)
endif(HAVE_SNAPPY)
if(HAVE_ZSTD)
  target_link_libraries(leveldb PUBLIC libzstd_static)
endif(HAVE_ZSTD)
if(HAVE_TCMALLOC)
  target_link_libraries(leveldb PUBLIC tcmalloc)
endif(HAVE_TCMALLOC)

# Needed by port_stdcxx.h
find_package(Threads REQUIRED)
target_link_libraries(leveldb PUBLIC Threads::Threads)

if (LEVELDB_BUILD_UTILS)
  add_executable(leveldbutil
    "db/leveldbutil.cc"
  )
  target_link_libraries(leveldbutil leveldb)
endif()

if(LEVELDB_BUILD_TESTS)
  enable_testing()

  # Prevent overriding the parent project's compiler/linker settings on Windows.
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
  set(install_gtest OFF)
  set(install_gmock OFF)
  set(build_gmock ON)

  # This project is tested using GoogleTest.
  add_subdirectory("third_party/googletest")

  # GoogleTest triggers a missing field initializers warning.
  if(LEVELDB_HAVE_NO_MISSING_FIELD_INITIALIZERS)
    set_property(TARGET gtest
        APPEND PROPERTY COMPILE_OPTIONS -Wno-missing-field-initializers)
    set_property(TARGET gmock
        APPEND PROPERTY COMPILE_OPTIONS -Wno-missing-field-initializers)
  endif(LEVELDB_HAVE_NO_MISSING_FIELD_INITIALIZERS)

  add_executable(leveldb_tests "")
  target_sources(leveldb_tests
    PRIVATE
      # "db/fault_injection_test.cc"
      # "issues/issue178_test.cc"
      # "issues/issue200_test.cc"
      # "issues/issue320_test.cc"
      "${PROJECT_BINARY_DIR}/${LEVELDB_PORT_CONFIG_DIR}/port_config.h"
      # "util/env_test.cc"
      "util/status_test.cc"
      "util/no_destructor_test.cc"
      "util/testutil.cc"
      "util/testutil.h"
  )
  if(NOT BUILD_SHARED_LIBS)
    target_sources(leveldb_tests
      PRIVATE
        "db/autocompact_test.cc"
        "db/corruption_test.cc"
        "db/db_test.cc"
        "db/dbformat_test.cc"
        "db/filename_test.cc"
        "db/log_test.cc"
        "db/recovery_test.cc"
        "db/skiplist_test.cc"
        "db/version_edit_test.cc"
        "db/version_set_test.cc"
        "db/write_batch_test.cc"
        "helpers/memenv/memenv_test.cc"
        "table/filter_block_test.cc"
        "table/table_test.cc"
        "util/arena_test.cc"
        "util/bloom_test.cc"
        "util/cache_test.cc"
        "util/coding_test.cc"
        "util/crc32c_test.cc"
        "util/hash_test.cc"
        "util/logging_test.cc"
    )
  endif(NOT BUILD_SHARED_LIBS)
  target_link_libraries(leveldb_tests leveldb gmock gtest gtest_main)
  target_compile_definitions(leveldb_tests
    PRIVATE
      ${LEVELDB_PLATFORM_NAME}=1
  )
  if (NOT HAVE_CXX17_HAS_INCLUDE)
    target_compile_definitions(leveldb_tests
      PRIVATE
        LEVELDB_HAS_PORT_CONFIG_H=1
    )
  endif(NOT HAVE_CXX17_HAS_INCLUDE)

  add_test(NAME "leveldb_tests" COMMAND "leveldb_tests")

  function(leveldb_test test_file)
    get_filename_component(test_target_name "${test_file}" NAME_WE)

    add_executable("${test_target_name}" "")
    target_sources("${test_target_name}"
      PRIVATE
        "${PROJECT_BINARY_DIR}/${LEVELDB_PORT_CONFIG_DIR}/port_config.h"
        "util/testutil.cc"
        "util/testutil.h"

        "${test_file}"
    )
    target_link_libraries("${test_target_name}" leveldb gmock gtest)
    target_compile_definitions("${test_target_name}"
      PRIVATE
        ${LEVELDB_PLATFORM_NAME}=1
    )
    if (NOT HAVE_CXX17_HAS_INCLUDE)
      target_compile_definitions("${test_target_name}"
        PRIVATE
          LEVELDB_HAS_PORT_CONFIG_H=1
      )
    endif(NOT HAVE_CXX17_HAS_INCLUDE)

    add_test(NAME "${test_target_name}" COMMAND "${test_target_name}")
  endfunction(leveldb_test)

  leveldb_test("db/c_test.c")

  if(NOT BUILD_SHARED_LIBS)
    # TODO(costan): This test also uses
    #               "util/env_{posix|windows}_test_helper.h"
    if (WIN32)
      leveldb_test("util/env_windows_test.cc")
    else (WIN32)
      leveldb_test("util/env_posix_test.cc")
    endif (WIN32)
  endif(NOT BUILD_SHARED_LIBS)
endif(LEVELDB_BUILD_TESTS)

if(LEVELDB_BUILD_BENCHMARKS)

=== debian/changelog ===
yass (1.20.4-1) UNRELEASED; urgency=medium

  * miscellaneous fixes
 -- Chilledheart <hukeyue@vip.163.com>  Fri, 2 Jan 2026 15:16:25 +0800

yass (1.20.3-1) UNRELEASED; urgency=medium

  * miscellaneous fixes
  * add debian loong64 port (cli)
  * add debian riscv64 port (gtk3)
 -- Chilledheart <hukeyue@vip.163.com>  Mon, 29 Dec 2025 17:50:23 +0800

yass (1.20.2-1) UNRELEASED; urgency=medium

  * miscellaneous fixes
 -- Chilledheart <hukeyue@vip.163.com>  Fri, 26 Dec 2025 13:21:58 +0800

yass (1.20.1-1) UNRELEASED; urgency=medium

  * miscellaneous fixes
 -- Chilledheart <hukeyue@vip.163.com>  Fri, 12 Dec 2025 20:02:57 +0800

yass (1.20.0-1) UNRELEASED; urgency=medium

  * bump to chromium 144 dependents.
  * license: make source code CDDL-1.0 compatible
 -- Chilledheart <hukeyue@vip.163.com>  Mon, 8 Dec 2025 17:56:56 +0800

yass (1.17.2-1) UNRELEASED; urgency=medium
  * tls: correct ECDSA verification for FIPS.

 -- Chilledheart <hukeyue@vip.163.com>  Thu, 18 Sep 2025 11:32:53 +0800

yass (1.17.1-1) UNRELEASED; urgency=medium
  * undocumented changes.

 -- Chilledheart <hukeyue@vip.163.com>  Wed, 17 Sep 2025 11:41:28 +0800

yass (1.17.0-1) UNRELEASED; urgency=medium

  * bump to chromium 141 dependents.
  * net: replace folly::IOBuf with google::IOBuffer.
  * tls: enable ML-KEM on all platforms by installation.
  * undocumented changes.

 -- Chilledheart <hukeyue@vip.163.com>  Tue, 16 Sep 2025 20:55:15 +0800

yass (1.16.2-1) UNRELEASED; urgency=medium

  * cli: reduce memory usage per connection.
  * base: use DCHECK_IS_ON for check_op.
  * net: handle ip-address like hostname correctly.
  * net: listen to EPOLLRDHUP/POLLRDHUP events.
  * net: fix ssl socket re-use issus when trying different endpoint.
  * net: avoid already_open error when opening next endpoint.
  * tls: load very first ca-bundle file only.
  * tls: update for fedora and rhel update.

 -- Chilledheart <hukeyue@vip.163.com>  Sun, 1 Dec 2024 09:44:59 +0800

yass (1.16.1-1) UNRELEASED; urgency=medium

  * tls: add adjust system trusted CA folder for linux.
  * tls: --capath now accepts separated list of directories.
  * cli: handle http/1.1 keepalive for different host properly.
  * cli: increase nofile to 65536 (systemd).
  * network: increase parallel_max to 65535.
  * network: apply keep alive on connections between client and browsers.
  * tls: use builtin ca store universally.
  * tls: ship GTS Root R4 with supplementary ca.

 -- Chilledheart <hukeyue@vip.163.com>  Mon, 18 Nov 2024 16:48:23 +0800

yass (1.16.0-1) UNRELEASED; urgency=medium

  * bump to chromium 132 dependents.
  * build: add an option to enable/disable assertions.
  * core: move logging and other modules to googleurl.
  * http2: handle HTTP/2 status code in response.
  * http2: handle HTTP/2 Push as soft error.
  * tls: enable reusable sessions.
  * tls: enable post quantum option for server-side.
  * tls: support both of mlkem and kyber for server-side.
  * tls: enable ALPS for HTTP/2 only.

 -- Chilledheart <hukeyue@vip.163.com>  Tue, 12 Nov 2024 12:17:34 +0800

yass (1.15.4-1) UNRELEASED; urgency=medium

  * cli: reduce memory usage per connection.
  * base: use DCHECK_IS_ON for check_op.
  * net: handle ip-address like hostname correctly.
  * net: listen to EPOLLRDHUP/POLLRDHUP events.
  * net: fix ssl socket re-use issus when trying different endpoint.
  * net: avoid already_open error when opening next endpoint.
  * tls: load very first ca-bundle file only.
  * tls: update for fedora and rhel update.
  * tls: add adjust system trusted CA folder for linux.
  * tls: --capath now accepts separated list of directories.
  * cli: handle http/1.1 keepalive for different host properly.
  * cli: increase nofile to 65536 (systemd).
  * network: increase parallel_max to 65535.
  * network: apply keep alive on connections between client and browsers.
  * tls: use builtin ca store universally.
  * tls: ship GTS Root R4 with supplementary ca.
  * http2: handle HTTP/2 status code in response.
  * tls: enable reusable sessions.

 -- Chilledheart <keeyou-cn@outlook.com>  Fri, 1 Nov 2024 09:44:59 +0800

yass (1.15.3-1) UNRELEASED; urgency=medium

  * http2: handle HTTP/2 Push as soft error.

 -- Chilledheart <hukeyue@vip.163.com>  Wed, 30 Oct 2024 09:46:13 +0800

yass (1.15.2-1) UNRELEASED; urgency=medium

  * some trivial changes.

 -- Chilledheart <hukeyue@vip.163.com>  Thu, 24 Oct 2024 11:08:12 +0800

yass (1.15.1-1) UNRELEASED; urgency=medium

  * build: add an option to enable/disable assertions.
  * tls: enable post quantum option for server-side.
  * tls: support both of mlkem and kyber for server-side.
  * tls: enable ALPS for HTTP/2 only.
  * core: move logging and other modules to googleurl.

 -- Chilledheart <hukeyue@vip.163.com>  Thu, 24 Oct 2024 10:36:37 +0800

yass (1.15.0-1) UNRELEASED; urgency=medium

  * bump to chromium 131 dependents.
  * net: optimize yield algorithm.
  * net: fix http proxy integration with qt 6.8.
  * tls: support and enable ML-KEM by default.
  * tls: support post quantumn key-agreements in server side.
  * tls: fix crash due to dangling DoPeek call.
  * cli: add stats for yield event.
  * systemd: update sample config files.
  * systemd: increase RestartSec to 5s.

 -- Chilledheart <hukeyue@vip.163.com>  Tue, 15 Oct 2024 13:04:44 +0800

yass (1.14.4-1) UNRELEASED; urgency=medium

  * net: fix http proxy integration with telegram.
  * qt: fix translation with post quantumn key-agreements.

 -- Chilledheart <hukeyue@vip.163.com>  Thu, 10 Oct 2024 18:31:24 +0800

yass (1.14.3-1) UNRELEASED; urgency=medium

  * tls: support and enable ML-KEM by default.
  * tls: support post quantumn key-agreements in server side.
  * tls: fix crash due to dangling DoPeek call.

 -- Chilledheart <hukeyue@vip.163.com>  Tue, 8 Oct 2024 12:53:13 +0800

yass (1.14.2-1) UNRELEASED; urgency=medium

  * systemd: update sample config files.

 -- Chilledheart <hukeyue@vip.163.com>  Sun, 6 Oct 2024 10:01:41 +0800



=== debian/control ===
Source: yass
Maintainer: Chilledheart <hukeyue@vip.163.com>
Section: net
Priority: optional
Standards-Version: 3.9.2
Build-Depends:
 cmake:native (>= 3.12),
 perl:native,
 gcc:native (>= 6.1),
 g++:native (>= 6.1),
 golang:native,
 ninja-build:native,
 debhelper (>= 9),
 pkg-config,
 zlib1g-dev,
 libcurl4-openssl-dev <!nocheck>,
 libglib2.0-dev <gtk3>,
 libgtk-3-dev <gtk3>,
 libglib2.0-dev <gtk4>,
 libgtk-4-dev <gtk4>,
 qtbase5-dev <qt5>,
 qt6-base-dev <qt6>
Rules-Requires-Root: no
Homepage: https://github.com/Chilledheart/yass
Vcs-Git: https://github.com/Chilledheart/yass.git
Vcs-Browser: https://github.com/Chilledheart/yass

Package: yass
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Build-Profiles: <gtk3> <gtk4> <qt5> <qt6>
Recommends:
 libappindicator3-1 <gtk3>,
 libayatana-appindicator3-1 <gtk3>
Depends:
 lsb-base (>= 3.0-6),
 ca-certificates,
 ${misc:Depends},
 ${shlibs:Depends}
Description: lightweight and secure http/socks4/socks5 proxy
 yass is a lightweight and secure http/socks proxy
 for embedded devices and low end boxes.

Package: yass-dbg
Section: debug
Architecture: any
Build-Profiles: <gtk3> <gtk4> <qt5> <qt6>
Depends:
    yass (= ${binary:Version}),
    ${misc:Depends},
Description: Debugging symbols for the yass package.
 This package contains the debugging symbols for the yass package.

Package: yass-server
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 lsb-base (>= 3.0-6),
 ca-certificates,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: ca-certificates
Description: lightweight and secure http/socks4/socks5 proxy
 yass is a lightweight and secure http/socks proxy
 for embedded devices and low end boxes.

Package: yass-server-dbg
Section: debug
Architecture: any
Depends:
    yass-server (= ${binary:Version}),
    ${misc:Depends},
Description: Debugging symbols for the yass-server package.
 This package contains the debugging symbols for the yass-server package.

Package: yass-client
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 lsb-base (>= 3.0-6),
 ca-certificates,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends: ca-certificates
Description: lightweight and secure http/socks4/socks5 proxy
 yass is a lightweight and secure http/socks proxy
 for embedded devices and low end boxes.

Package: yass-client-dbg
Section: debug
Architecture: any
Depends:
    yass-client (= ${binary:Version}),
    ${misc:Depends},
Description: Debugging symbols for the yass-client package.
 This package contains the debugging symbols for the yass-client package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# Security Hardening
export DEB_BUILD_MAINT_OPTIONS += hardening=+all
NCPUS = $(shell nproc)

export GOPROXY

# In compat 13 and later, The variables HOME will be set to a writable directory
export HOME=/tmp

# mark as official build
CMAKE_OPTIONS += -DOFFICIAL_BUILD=on

CMAKE_OPTIONS += ${CMAKE_CROSS_TOOLCHAIN_FLAGS_NATIVE}

# this fix is required before debhelper 11.4
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=907738
ifneq ($(DH_QUIET),)
CMAKE_OPTIONS += -DCMAKE_VERBOSE_MAKEFILE=OFF
endif

ifneq ($(filter qt6,$(DEB_BUILD_PROFILES)),)
	CMAKE_OPTIONS += -DGUI=on -DUSE_QT6=on
else ifneq ($(filter qt5,$(DEB_BUILD_PROFILES)),)
	CMAKE_OPTIONS += -DGUI=on -DUSE_QT6=off -DUSE_QT5=on
else ifneq ($(filter gtk4,$(DEB_BUILD_PROFILES)),)
	CMAKE_OPTIONS += -DGUI=on -DUSE_QT6=off -DUSE_QT5=off -DUSE_GTK4=on
else ifneq ($(filter gtk3,$(DEB_BUILD_PROFILES)),)
	CMAKE_OPTIONS += -DGUI=on -DUSE_QT6=off -DUSE_QT5=off -DUSE_GTK4=off
else
	CMAKE_OPTIONS += -DGUI=off
endif

export ASMFLAGS
export PKG_CONFIG

%:
	dh $@ --builddirectory=build-debian

override_dh_auto_clean:
	dh_auto_clean

ifneq ($(filter clang,$(DEB_BUILD_PROFILES)),)
override_dh_auto_configure: ASMFLAGS += -ccc-gcc-name ${DEB_HOST_GNU_TYPE}-gcc
override_dh_auto_configure: CFLAGS += -ccc-gcc-name ${DEB_HOST_GNU_TYPE}-gcc
override_dh_auto_configure: CXXFLAGS += -ccc-gcc-name ${DEB_HOST_GNU_TYPE}-g++
CMAKE_OPTIONS += -DCMAKE_C_COMPILER_TARGET=${DEB_HOST_GNU_TYPE} -DCMAKE_CXX_COMPILER_TARGET=${DEB_HOST_GNU_TYPE} -DCMAKE_ASM_COMPILER_TARGET=${DEB_HOST_GNU_TYPE}
ifneq ($(filter riscv64,$(DEB_HOST_GNU_CPU)),)
# According to the ISA spec definition rv64gc is rv64imafdc_zicsr_zifencei and
# rv64imafdc is rv64imafdc_zicsr, see https://github.com/riscv-collab/riscv-gcc/issues/344
override_dh_auto_configure: ASMFLAGS += -march=rv64gc -mabi=lp64d
override_dh_auto_configure: CFLAGS += -march=rv64gc -mabi=lp64d
override_dh_auto_configure: CXXFLAGS += -march=rv64gc -mabi=lp64d
endif
endif

ifneq ($(filter cross,$(DEB_BUILD_PROFILES)),)
override_dh_auto_configure: PKG_CONFIG = ${DEB_HOST_GNU_TYPE}-pkg-config
endif

override_dh_auto_configure: CMAKE_OPTIONS += -DENABLE_LTO=on -DENABLE_LLD=on -DUSE_LIBCXX=on
override_dh_auto_configure: CMAKE_OPTIONS += -DUSE_ZLIB=on -DUSE_SYSTEM_ZLIB=on
override_dh_auto_configure: CMAKE_OPTIONS += -DUSE_JSONCPP=on
override_dh_auto_configure: CMAKE_OPTIONS += -DUSE_CARES=on
override_dh_auto_configure: CMAKE_OPTIONS += -DCMAKE_SYSTEM_NAME=Linux -DCMAKE_SYSTEM_PROCESSOR=$(DEB_HOST_ARCH)
override_dh_auto_configure: CMAKE_OPTIONS += -DUSE_OLD_SYSTEMD_SERVICE=on

ifneq ($(filter cet,$(DEB_BUILD_PROFILES)),)
override_dh_auto_configure: CMAKE_OPTIONS += -DUSE_CET=on
endif

override_dh_auto_configure:
	dh_auto_configure ${DEB_BUILD_SYSTEM_OPTIONS} -- -DCMAKE_BUILD_TYPE=Release -DBUILD_BENCHMARKS=on -DBUILD_TESTS=on $(CMAKE_OPTIONS) -DCLI=on -DSERVER=on -DUSE_TCMALLOC=on

override_dh_auto_build:
	dh_auto_build ${DEB_BUILD_SYSTEM_OPTIONS} -- -j $(NCPUS)

override_dh_auto_test:
ifneq ($(filter nocheck,$(DEB_BUILD_PROFILES)),)
	echo 'test skipped'
else
	./build-debian/yass_test
	./build-debian/yass_benchmark
endif

override_dh_shlibdeps:
	dh_shlibdeps -l /usr/$(DEB_HOST_GNU_TYPE)/lib -l /lib/$(DEB_HOST_GNU_TYPE)

override_dh_strip:
ifneq ($(filter qt6,$(DEB_BUILD_PROFILES)),)
	dh_strip -pyass --dbg-package=yass-dbg
else ifneq ($(filter qt5,$(DEB_BUILD_PROFILES)),)
	dh_strip -pyass --dbg-package=yass-dbg
else ifneq ($(filter gtk4,$(DEB_BUILD_PROFILES)),)
	dh_strip -pyass --dbg-package=yass-dbg
else ifneq ($(filter gtk3,$(DEB_BUILD_PROFILES)),)
	dh_strip -pyass --dbg-package=yass-dbg
endif
	dh_strip -pyass-server --dbg-package=yass-server-dbg
	dh_strip -pyass-client --dbg-package=yass-client-dbg
